--[[--
@module MyDungeonsBook
]]

--[[--
Mechanics
@section Mechanics
]]

local DungeonsMetaInfo = {

    -------------
    ---- WoD ----
    -------------

    -- BSM
    [1175] = {
        instanceId = 1175,
        addon = "WoD",
        name = "Bloodmaul Slag Mines",
        waInfo = {
            gameZoneId = "573"
        },
        encounters = {
            [1652] = {
                name = "Roltall",
                encounterId = 1652
            },
            [1653] = {
                name = "Slave Watcher Crushto",
                encounterId = 1653
            },
            [1654] = {
                name = "Gug'rokk",
                encounterId = 1654
            },
            [1655] = {
                name = "Magmolatus",
                encounterId = 1655
            }
        }
    },

    -- GD
    [1208] = {
        instanceId = 1208,
        addon = "WoD",
        name = "Grimrail Depot",
        waInfo = {
            gameZoneId = "g225"
        },
        encounters = {
            [1715] = {
                name = "Rocketspark and Borka",
                encounterId = 1715
            },
            [1732] = {
                name = "Nitrogg Thundertower",
                encounterId = 1732
            },
            [1736] = {
                name = "Skylord Tovra",
                encounterId = 1736
            }
        }
    },

    -- ID
    [1195] = {
        instanceId = 1195,
        addon = "WoD",
        name = "Iron Docks",
        waInfo = {
            gameZoneId = "595"
        },
        encounters = {
            [1748] = {
                name = "Grimrail Enforcers",
                encounterId = 1748
            },
            [1749] = {
                name = "Fleshrender Nok'gar",
                encounterId = 1749
            },
            [1750] = {
                name = "Oshir",
                encounterId = 1750
            },
            [1754] = {
                name = "Skulloc, Son of Gruul",
                encounterId = 1754
            }
        }
    },

    -- Auchindoun
    [1182] = {
        instanceId = 1182,
        addon = "WoD",
        name = "Auchindoun",
        waInfo = {
            gameZoneId = "593"
        },
        encounters = {
            [1678] = {
                name = "Azzakel, Vanguard of the Legion",
                encounterId = 1678
            },
            [1685] = {
                name = "Soulbinder Nyami",
                encounterId = 1685
            },
            [1686] = {
                name = "Vigilant Kaathar",
                encounterId = 1686
            },
            [1714] = {
                name = "Teron'gor",
                encounterId = 1714
            }
        }
    },

    -- TE
    [1279] = {
        instanceId = 1279,
        addon = "WoD",
        name = "The Everbloom",
        waInfo = {
            gameZoneId = "g236"
        },
        encounters = {
            [1746] = {
                name = "Witherbark",
                encounterId = 1746
            },
            [1751] = {
                name = "Archmage Sol",
                encounterId = 1751
            },
            [1752] = {
                name = "Xeri'tac",
                encounterId = 1752
            },
            [1756] = {
                name = "Yalnu",
                encounterId = 1756
            },
            [1757] = {
                name = "Ancient Protectors",
                encounterId = 1757
            }
        }
    },

    -- Skyreach
    [1209] = {
        instanceId = 1209,
        addon = "WoD",
        name = "Skyreach",
        waInfo = {
            gameZoneId = "g226"
        },
        encounters = {
            [1698] = {
                name = "Ranjit",
                encounterId = 1698
            },
            [1699] = {
                name = "Araknath",
                encounterId = 1699
            },
            [1700] = {
                name = "Rukhran",
                encounterId = 1700
            },
            [1701] = {
                name = "High Sage Viryx",
                encounterId = 1701
            }
        }
    },

    -- UBS
    [1358] = {
        instanceId = 1358,
        addon = "WoD",
        name = "Upper Blackrock Spire",
        waInfo = {
            gameZoneId = "g237"
        },
        encounters = {
            [1758] = {
                name = "Kyrak",
                encounterId = 1758
            },
            [1759] = {
                name = "Commander Tharbek",
                encounterId = 1759
            },
            [1760] = {
                name = "Ragewing the Untamed",
                encounterId = 1760
            },
            [1761] = {
                name = "Orebender Gor'ashan",
                encounterId = 1761
            },
            [1762] = {
                name = "Warlord Zaela",
                encounterId = 1762
            }
        }
    },

    -- SBG
    [1176] = {
        instanceId = 1176,
        addon = "WoD",
        name = "Shadowmoon Burial Grounds",
        waInfo = {
            gameZoneId = "g223"
        },
        encounters = {
            [1677] = {
                name = "Sadana Bloodfury",
                encounterId = 1677
            },
            [1679] = {
                name = "Bonemaw",
                encounterId = 1679
            },
            [1682] = {
                name = "Ner'zhul",
                encounterId = 1682
            },
            [1688] = {
                name = "Nhallish",
                encounterId = 1688
            }
        }
    },

    ----------------
    ---- LEGION ----
    ----------------

    -- EoA
    [1456] = {
        instanceId = 1456,
        addon = "LEGION",
        name = "Eye of Azshara",
        waInfo = {
            gameZoneId = "713"
        },
        encounters = {
            [1810] = {
                name = "Warlord Parjesh",
                encounterId = 1810
            },
            [1811] = {
                name = "Lady Hatecoil",
                encounterId = 1811
            },
            [1812] = {
                name = "King Deepbeard",
                encounterId = 1812
            },
            [1813] = {
                name = "Serpentrix",
                encounterId = 1813
            },
            [1814] = {
                name = "Wrath of Azshara",
                encounterId = 1814
            }
        }
    },

    -- NL
    [1458] = {
        instanceId = 1458,
        addon = "LEGION",
        name = "Neltharion's Lair",
        waInfo = {
            gameZoneId = "731"
        },
        encounters = {
            [1790] = {
                name = "Rokmora",
                encounterId = 1790
            },
            [1791] = {
                name = "Ularogg Cragshaper",
                encounterId = 1791
            },
            [1792] = {
                name = "Naraxas",
                encounterId = 1792
            },
            [1793] = {
                name = "Dargrul the Underking",
                encounterId = 1793
            }
        }
    },

    -- DT
    [1466] = {
        instanceId = 1466,
        addon = "LEGION",
        name = "Darkheart Thicket",
        waInfo = {
            gameZoneId = "733"
        },
        encounters = {
            [1836] = {
                name = "Archdruid Glaidalis",
                encounterId = 1836
            },
            [1837] = {
                name = "Oakheart",
                encounterId = 1837
            },
            [1838] = {
                name = "Dresaron",
                encounterId = 1838
            },
            [1839] = {
                name = "Shade of Xavius",
                encounterId = 1839
            }
        }
    },

    -- HoV
    [1477] = {
        instanceId = 1477,
        addon = "LEGION",
        name = "Halls of Valor",
        waInfo = {
            gameZoneId = "g240"
        },
        encounters = {
            [1805] = {
                name = "Hymdall",
                encounterId = 1805
            },
            [1806] = {
                name = "Hyrja",
                encounterId = 1806
            },
            [1807] = {
                name = "Fenryr",
                encounterId = 1807
            },
            [1808] = {
                name = "God-King Skovald",
                encounterId = 1808
            },
            [1809] = {
                name = "Odyn",
                encounterId = 1809
            }
        }
    },

    -- MoS
    [1492] = {
        instanceId = 1492,
        addon = "LEGION",
        name = "Maw of Souls",
        waInfo = {
            gameZoneId = "g243"
        },
        encounters = {
            [1822] = {
                name = "Ymiron, the Fallen King",
                encounterId = 1822
            },
            [1823] = {
                name = "Harbaron",
                encounterId = 1823
            },
            [1824] = {
                name = "Helya",
                encounterId = 1824
            }
        }
    },

    -- VotW
    [1493] = {
        instanceId = 1493,
        addon = "LEGION",
        name = "Vault of the Wardens",
        waInfo = {
            gameZoneId = "g244"
        },
        encounters = {
            [1815] = {
                name = "Tirathon Saltheril",
                encounterId = 1815
            },
            [1816] = {
                name = "Ash'Golm",
                encounterId = 1816
            },
            [1817] = {
                name = "Glazer",
                encounterId = 1817
            },
            [1818] = {
                name = "Cordana Felsong",
                encounterId = 1818
            },
            [1850] = {
                name = "Inquisitor Tormentorum",
                encounterId = 1850
            }
        }
    },

    -- BRH
    [1501] = {
        instanceId = 1501,
        addon = "LEGION",
        name = "Black Rook Hold",
        waInfo = {
            gameZoneId = "g245"
        },
        encounters = {
            [1832] = {
                name = "Amalgam of Souls",
                encounterId = 1832
            },
            [1833] = {
                name = "Ilysanna Ravencrest",
                encounterId = 1833
            },
            [1834] = {
                name = "Smashspite the Hateful",
                encounterId = 1834
            },
            [1835] = {
                name = "Lord Kur'talos Ravencrest",
                encounterId = 1835
            }
        }
    },

    -- TA
    [1516] = {
        instanceId = 1516,
        addon = "LEGION",
        name = "The Arcway",
        waInfo = {
            gameZoneId = "749"
        },
        encounters = {
            [1825] = {
                name = "Corstilax",
                encounterId = 1825
            },
            [1826] = {
                name = "Nal'tira",
                encounterId = 1826
            },
            [1827] = {
                name = "Ivanyr",
                encounterId = 1827
            },
            [1828] = {
                name = "General Xakal",
                encounterId = 1828
            },
            [1829] = {
                name = "Advisor Vandros",
                encounterId = 1829
            }
        }
    },

    -- AoVH
    [1544] = {
        instanceId = 1544,
        addon = "LEGION",
        name = "Assault on Violet Hold",
        waInfo = {
            gameZoneId = "732"
        },
        encounters = {
            [1845] = {
                name = "Shivermaw",
                encounterId = 1845
            },
            [1846] = {
                name = "Mindflayer Kaahrj",
                encounterId = 1846
            },
            [1847] = {
                name = "Millificent Manastorm",
                encounterId = 1847
            },
            [1848] = {
                name = "Festerface",
                encounterId = 1848
            },
            [1851] = {
                name = "Sael'orn",
                encounterId = 1851
            },
            [1852] = {
                name = "Anub'esset",
                encounterId = 1852
            },
            [1855] = {
                name = "Blood-Princess Thal'ena",
                encounterId = 1855
            },
            [1856] = {
                name = "Fel Lord Betrug",
                encounterId = 1856
            }
        }
    },

    -- CoS
    [1571] = {
        instanceId = 1571,
        addon = "LEGION",
        name = "Court of Stars",
        waInfo = {
            gameZoneId = "g252"
        },
        encounters = {
            [1868] = {
                name = "Patrol Captain Gerdo",
                encounterId = 1868
            },
            [1869] = {
                name = "Talixae Flamewreath",
                encounterId = 1869
            },
            [1870] = {
                name = "Advisor Melandrus",
                encounterId = 1870
            }
        }
    },

    -- RtK
    [1651] = {
        instanceId = 1651,
        addon = "LEGION",
        name = "Return to Karazhan",
        waInfo = {
            gameZoneId = "g260"
        },
        encounters = {
            [1954] = {
                name = "Maiden of Virtue",
                encounterId = 1954
            },
            [1957] = {
                name = "Opera Hall",
                encounterId = 1957
            },
            [1959] = {
                name = "Mana Devourer",
                encounterId = 1959
            },
            [1960] = {
                name = "Attumen the Huntsman",
                encounterId = 1960
            },
            [1961] = {
                name = "Moroes",
                encounterId = 1961
            },
            [1964] = {
                name = "The Curator",
                encounterId = 1964
            },
            [1965] = {
                name = "Shade of Medivh",
                encounterId = 1965
            },
            [2017] = {
                name = "Viz'aduum the Watcher",
                encounterId = 2017
            },
            [2031] = {
                name = "Nightbane",
                encounterId = 2031
            }
        }
    },

    -- CoEN
    [1677] = {
        instanceId = 1677,
        addon = "LEGION",
        name = "Cathedral of Eternal Night",
        waInfo = {
            gameZoneId = "g265"
        },
        encounters = {
            [2039] = {
                name = "Mephistroth",
                encounterId = 2039
            },
            [2053] = {
                name = "Domatrax",
                encounterId = 2053
            },
            [2055] = {
                name = "Agronox",
                encounterId = 2055
            },
            [2057] = {
                name = "Thrashbite the Scornful",
                encounterId = 2057
            }
        }
    },

    -- SotT
    [1753] = {
        instanceId = 1753,
        addon = "LEGION",
        name = "Seat of the Triumvirate",
        waInfo = {
            gameZoneId = "903"
        },
        encounters = {
            [2065] = {
                name = "Zuraal the Ascended",
                encounterId = 2065
            },
            [2066] = {
                name = "Saprish",
                encounterId = 2066
            },
            [2067] = {
                name = "Viceroy Nezhar",
                encounterId = 2067
            },
            [2068] = {
                name = "L'ura",
                encounterId = 2068
            }
        }
    },

    -------------
    ---- BfA ----
    -------------

    -- TML
    [1594] = {
        instanceId = 1594,
        lastEncounterId = 2108,
        addon = "BfA",
        name = "The MOTHERLODE!!",
        waInfo = {
            gameZoneId = "1010"
        },
        encounters = {
            [2105] = {
                name = "Coin-Operated Crowd Pummeler",
                encounterId = 2105
            },
            [2106] = {
                name = "Azerokk",
                encounterId = 2106
            },
            [2107] = {
                name = "Rixxa Fluxfume",
                encounterId = 2107
            },
            [2108] = {
                name = "Mogul Razdunk",
                encounterId = 2108
            }
        }
    },

    -- FH
    [1754] = {
        instanceId = 1754,
        lastEncounterId = 2096,
        addon = "BfA",
        name = "Freehold",
        waInfo = {
            gameZoneId = "936"
        },
        encounters = {
            [2093] = {
                name = "Skycap'n Kragg",
                encounterId = 2093
            },
            [2094] = {
                name = "Council o' Captains",
                encounterId = 2094
            },
            [2095] = {
                name = "Ring of Booty",
                encounterId = 2095
            },
            [2096] = {
                name = "Lord Harlan Sweete",
                encounterId = 2096
            }
        }
    },

    -- KR
    [1762] = {
        instanceId = 1762,
        lastEncounterId = 2143,
        addon = "BfA",
        name = "Kings' Rest",
        waInfo = {
            gameZoneId = "1004"
        },
        encounters = {
            [2139] = {
                name = "The Golden Serpent",
                encounterId = 2139
            },
            [2140] = {
                name = "The Council of Tribes",
                encounterId = 2140
            },
            [2142] = {
                name = "Mchimba the Embalmer",
                encounterId = 2142
            },
            [2143] = {
                name = "King Dazar",
                encounterId = 2143
            }
        }
    },

    -- AD
    [1763] = {
        instanceId = 1763,
        lastEncounterId = 2087,
        addon = "BfA",
        name = "Atal'Dazar",
        waInfo = {
            gameZoneId = "g275"
        },
        encounters = {
            [2084] = {
                name = "Priestess Alun'za",
                encounterId = 2084
            },
            [2085] = {
                name = "Vol'kaal",
                encounterId = 2085
            },
            [2086] = {
                name = "Rezan",
                encounterId = 2086
            },
            [2087] = {
                name = "Yazma",
                encounterId = 2087
            }
        }
    },

    -- TD
    [1771] = {
        instanceId = 1771,
        lastEncounterId = 2104,
        addon = "BfA",
        name = "Tol Dagor",
        waInfo = {
            gameZoneId = "g277"
        },
        encounters = {
            [2101] = {
                name = "The Sand Queen",
                encounterId = 2101
            },
            [2102] = {
                name = "Jes Howlis",
                encounterId = 2102
            },
            [2103] = {
                name = "Knight Captain Valyri",
                encounterId = 2103
            },
            [2104] = {
                name = "Overseer Korgus",
                encounterId = 2104
            }
        }
    },

    -- SoB
    [1822] = {
        instanceId = 1822,
        addon = "BfA",
        lastEncounterId = 2100,
        name = "Siege of Boralus",
        waInfo = {
            gameZoneId = "1162"
        },
        encounters = {
            [2097] = {
                name = "Sergeant Bainbridge",
                encounterId = 2097
            },
            [2098] = {
                name = "Chopper Redhook",
                encounterId = 2098
            },
            [2099] = {
                name = "Hadal Darkfathom",
                encounterId = 2099
            },
            [2100] = {
                name = "Viq'Goth",
                encounterId = 2100
            },
            [2109] = {
                name = "Dread Captain Lockwood",
                encounterId = 2109
            }
        }
    },

    -- TU
    [1841] = {
        instanceId = 1841,
        lastEncounterId = 2123,
        addon = "BfA",
        name = "The Underrot",
        waInfo = {
            gameZoneId = "g282"
        },
        encounters = {
            [2111] = {
                name = "Elder Leaxa",
                encounterId = 2111
            },
            [2112] = {
                name = "Sporecaller Zancha",
                encounterId = 2112
            },
            [2118] = {
                name = "Cragmaw the Infested",
                encounterId = 2118
            },
            [2123] = {
                name = "Unbound Abomination",
                encounterId = 2123
            }
        }
    },

    -- WM
    [1862] = {
        instanceId = 1862,
        lastEncounterId = 2117,
        addon = "BfA",
        name = "Waycrest Manor",
        waInfo = {
            gameZoneId = "g279"
        },
        encounters = {
            [2113] = {
                name = "Heartsbane Triad",
                encounterId = 2113
            },
            [2114] = {
                name = "Soulbound Goliath",
                encounterId = 2114
            },
            [2115] = {
                name = "Raal the Gluttonous",
                encounterId = 2115
            },
            [2116] = {
                name = "Lord and Lady Waycrest",
                encounterId = 2116
            },
            [2117] = {
                name = "Gorak Tul",
                encounterId = 2117
            }
        }
    },

    -- SotS
    [1864] = {
        instanceId = 1864,
        lastEncounterId = 2133,
        addon = "BfA",
        name = "Shrine of the Storm",
        waInfo = {
            gameZoneId = "g281"
        },
        encounters = {
            [2130] = {
                name = "Aqu'sirr",
                encounterId = 2130
            },
            [2131] = {
                name = "Tidesage Council",
                encounterId = 2131
            },
            [2132] = {
                name = "Lord Stormsong",
                encounterId = 2132
            },
            [2133] = {
                name = "Vol'zith the Whisperer",
                encounterId = 2133
            }
        }
    },
    
    -- ToS
    [1877] = {
        instanceId = 1877,
        lastEncounterId = 2127,
        addon = "BfA",
        name = "Temple of Sethraliss",
        waInfo = {
            gameZoneId = "g283"
        },
        encounters = {
            [2124] = {
                name = "Adderis and Aspix",
                encounterId = 2124
            },
            [2125] = {
                name = "Merektha",
                encounterId = 2125
            },
            [2126] = {
                name = "Galvazzt",
                encounterId = 2126
            },
            [2127] = {
                name = "Avatar of Sethraliss",
                encounterId = 2127
            }
        }
    },

    -- OP
    [2097] = {
        instanceId = 2097,
        addon = "BfA",
        lastEncounterId = 2290,
        secondLastEncounterId = 2291,
        name = "Operation: Mechagon",
        waInfo = {
            gameZoneId = "g399"
        },
        encounters = {
            [2257] = {
                name = "Tussle Tonks",
                encounterId = 2257
            },
            [2258] = {
                name = "K.U.-J.0.",
                encounterId = 2258
            },
            [2259] = {
                name = "Machinist's Garden",
                encounterId = 2259
            },
            [2260] = {
                name = "King Mechagon",
                encounterId = 2260
            },
            [2290] = {
                name = "King Gobbamak",
                encounterId = 2290
            },
            [2291] = {
                name = "HK-8 Aerial Oppression Unit",
                encounterId = 2291
            },
            [2292] = {
                name = "Gunker",
                encounterId = 2292
            },
            [2312] = {
                name = "Trixie & Naeno",
                encounterId = 2312
            }
        }
    },

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- SoA
    [2285] = {
        instanceId = 2285,
        lastEncounterId = 2359,
        addon = "SL",
        name = "Spires of Ascension",
        waInfo = {
            gameZoneId = "g419",
        },
        encounters = {
            [2357] = {
                name = "Kin-Tara",
                encounterId = 2357,
            },
            [2356] = {
                name = "Ventunax",
                encounterId = 2356,
            },
            [2358] = {
                name = "Oryphrion",
                encounterId = 2358,
            },
            [2359] = {
                name = "Devos, Paragon of Loyalty",
                encounterId = 2359,
            },
        },
    },

    -- MotS
    [2290] = {
        instanceId = 2290,
        lastEncounterId = 2393,
        addon = "SL",
        name = "Mists of Tirna Scithe",
        waInfo = {
            gameZoneId = "1669",
        },
        encounters = {
            [2397] = {
                name = "Ingra Maloch",
                encounterId = 2397,
            },
            [2392] = {
                name = "Mistcaller",
                encounterId = 2392,
            },
            [2393] = {
                name = "Tred'ova",
                encounterId = 2393,
            },
        },
    },

    -- PF
    [2289] = {
        instanceId = 2289,
        lastEncounterId = 2386,
        addon = "SL",
        name = "Plaguefall",
        waInfo = {
            gameZoneId = "g415",
        },
        encounters = {
            [2382] = {
                name = "Globgrog",
                encounterId = 2382,
            },
            [2384] = {
                name = "Doctor Ickus",
                encounterId = 2384,
            },
            [2385] = {
                name = "Domina Venomblade",
                encounterId = 2385,
            },
            [2386] = {
                name = "Stradama Margrave",
                encounterId = 2386,
            },
        },
    },

    -- SD
    [2284] = {
        instanceId = 2284,
        lastEncounterId = 2363,
        addon = "SL",
        name = "Sanguine Depths",
        waInfo = {
            gameZoneId = "g412",
        },
        encounters = {
            [2360] = {
                name = "Kryxis the Voracious",
                encounterId = 2360,
            },
            [2361] = {
                name = "Executor Tarvold",
                encounterId = 2361,
            },
            [2362] = {
                name = "Grand Proctor Beryllia",
                encounterId = 2362,
            },
            [2363] = {
                name = "General Kaal",
                encounterId = 2363,
            },
        },
    },

    -- ToP
    [2293] = {
        instanceId = 2293,
        lastEncounterId = 2404,
        addon = "SL",
        name = "Theater of Pain",
        waInfo = {
            gameZoneId = "g414",
        },
        encounters = {
            [2391] = {
                name = "An Affront of Challengers",
                encounterId = 2391,
            },
            [2365] = {
                name = "Gorechop",
                encounterId = 2365,
            },
            [2366] = {
                name = "Xav the Unfallen",
                encounterId = 2366,
            },
            [2364] = {
                name = "Kul'tharok",
                encounterId = 2364,
            },
            [2404] = {
                name = "Mordretha",
                encounterId = 2404,
            },
        },
    },

    -- NW
    [2286] = {
        instanceId = 2286,
        lastEncounterId = 2390,
        addon = "SL",
        name = "The Necrotic Wake",
        waInfo = {
            gameZoneId = "g410",
        },
        encounters = {
            [2387] = {
                name = "Blightbone",
                encounterId = 2387,
            },
            [2388] = {
                name = "Amarth, The Harvester",
                encounterId = 2388,
            },
            [2389] = {
                name = "Surgeon Stitchflesh",
                encounterId = 2389,
            },
            [2390] = {
                name = "Nalthor the Rimebinder",
                encounterId = 2390,
            },
        },
    },

    -- DoS
    [2291] = {
        instanceId = 2291,
        lastEncounterId = 2396,
        addon = "SL",
        name = "De Other Side",
        waInfo = {
            gameZoneId = "g413",
        },
        encounters = {
            [2395] = {
                name = "Hakkar, the Soulflayer",
                encounterId = 2395,
            },
            [2394] = {
                name = "The Manastorms",
                encounterId = 2394,
            },
            [2400] = {
                name = "Dealer Xy'exa",
                encounterId = 2400,
            },
            [2396] = {
                name = "Mueh'zala",
                encounterId = 2396,
            },
        },
    },

    -- HoA
    [2287] = {
        instanceId = 2287,
        lastEncounterId = 2381,
        addon = "SL",
        name = "Halls of Atonement",
        waInfo = {
            gameZoneId = "g409",
        },
        encounters = {
            [2401] = {
                name = "Halkias, the Sin-Stained Goliath",
                encounterId = 2401,
            },
            [2380] = {
                name = "Echelon",
                encounterId = 2380,
            },
            [2403] = {
                name = "High Adjudicator Aleez",
                encounterId = 2403,
            },
            [2381] = {
                name = "Lord Chamberlain",
                encounterId = 2381,
            },
        },
    },

    -- Tazavesh, the Veiled Market
    [2441] = {
        instanceId = 2441,
        lastEncounterId = 2442,
        secondLastEncounterId = 2437,
        addon = "SL",
        name = "Tazavesh, the Veiled Market",
        waInfo = {
            gameZoneId = "g423",
        },
        encounters = {
            [2425] = {
                name = "Zo'phex the Sentinel",
                encounterId = 2425,
            },
            [2441] = {
                name = "The Grand Menagerie",
                encounterId = 2441,
            },
            [2424] = {
                name = "Mailroom Mayhem",
                encounterId = 2424,
            },
            [2440] = {
                name = "Myza's Oasis",
                encounterId = 2440,
            },
            [2437] = {
                name = "So'azmi",
                encounterId = 2437,
            },
            [2426] = {
                name = "Hylbrande",
                encounterId = 2426,
            },
            [2419] = {
                name = "Timecap'n Hooktail",
                encounterId = 2419,
            },
            [2442] = {
                name = "So'leah",
                encounterId = 2442,
            },
        },
    },
};

function MyDungeonsBook:GetDungeonsMetaInfo()
    return DungeonsMetaInfo;
end

function MyDungeonsBook:GetDungeonMetaInfo(instanceId)
    return DungeonsMetaInfo[instanceId] or {};
end
