--[[--
@module MyDungeonsBook
]]

--[[--
Mechanics
@section Mechanics
]]

local L = LibStub("AceLocale-3.0"):GetLocale("MyDungeonsBook");

local Spells = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks
    [164632] = true,
    [165152] = true,        -- Lava Sweep
    [168148] = true,
    [168390] = true,
    [168514] = true,
    [173349] = true,        -- Trampled
    [173517] = true,
    [173489] = true,
    [172963] = true,

    -- Grimrail Depot
    [162513] = true,
    [171902] = true,
    [167038] = true,
    [160963] = true,
    [176025] = true,
    [162065] = true,
    [161588] = true,
    [163971] = true,

    ----------------
    ---- LEGION ----
    ----------------

    -- Affixes
    [360855] = true,        -- Fel Bombardment
    [360909] = true,        -- Eye Beam

    -- Black Rock Hold
    [194956] = true,        -- Reap Soul (Amalgam of Souls)
    [198820] = true,        -- Dark Blast (Latosius)
    [200261] = true,        -- Bonebreaking Strike
    [200914] = true,        -- Indigestion
    [214002] = true,        -- Raven's Dive

    -- Court of Stars
    [206574] = true,        -- Resonant Slash
    [207979] = true,        -- Shockwave
    [209027] = true,        -- Quelling Strike
    [209477] = true,        -- Wild Detonation
    [209630] = true,        -- Piercing Gale
    [214688] = true,        -- Carrion Swarm
    [219498] = true,        -- Streetsweeper

    -- Darkheart Thicket
    [191326] = true,        -- Breath of Corruption
    [198916] = true,        -- Vile Burst
    [198408] = true,        -- Nightfall
    [200329] = true,        -- Overwhelming Terror
    [201123] = true,        -- Root Burst
    [201227] = true,        -- Blood Assault
    [201273] = true,        -- Blood Bomb
    [204402] = true,        -- Star Shower
    [204667] = true,        -- Nightmare Breath
    [218759] = true,        -- Corruption Pool

    -- Eye of Azshara
    [191919] = true,        -- Crashing Wave (Warlord Parjesh)
    [191847] = true,        -- Poison Spit
    [191977] = true,        -- Impaling Spear (Warlord Parjesh)
    [192003] = true,        -- Blazing Nova
    [192005] = true,        -- Arcane Blast
    [192053] = true,        -- Quicksand (Warlord Parjesh)
    [192675] = true,        -- Mystic Tornado
    [192696] = true,        -- Raging Storms
    [192708] = true,        -- Arcane Bomb
    [192794] = true,        -- Lightning Strike
    [193597] = true,        -- Static Nova (Lady Hatecoil)
    [195104] = true,        -- Spiked Carapace
    [195217] = true,        -- Aqua Spout
    [195473] = true,        -- Abrasive Slime
    [195541] = true,        -- Water Spout
    [196129] = true,        -- Spray Sand (Mak'rana Siltwalker)
    [196871] = true,        -- Storm
    [197326] = true,        -- Crackling Thunder (Lady Hatecoil)
    [199948] = true,        -- Tempest

    -- Neltharion's Lair
    [188169] = true,        -- Razor Shards
    [193585] = true,        -- Bound
    [215929] = true,        -- Rupturing Skitter
    [217090] = true,        -- Magma Wave
    [226296] = true,        -- Piercing Shards
    [226304] = true,
    [183100] = true,
    [183088] = true,
    [192800] = true,
    [226388] = true,
    [183407] = true,
    [200338] = true,

    -- Vault of the Wardens
    [191743] = true,        -- Deafening Screech
    [197541] = true,        -- Detonation

    -- Karazhan Lower
    [228625] = true,
    [228019] = true,
    [227542] = true,
    [227776] = true,
    [227473] = true,
    [227977] = true,
    [29579] = true,
    [232115] = true,
    [227925] = true,
    [228001] = true,
    [227341] = true,
    [241784] = true,
    [227434] = true,
    [227480] = true,

    -- Karazhan Upper
    [242894] = true,
    [228262] = true,
    [229988] = true,
    [227285] = true,
    [229597] = true,
    [227806] = true,
    [229083] = true,
    [229298] = true,
    [229544] = true,
    [229567] = true,
    [229248] = true,
    [229285] = true,
    [229151] = true,
    [229384] = true,
    [229161] = true,
    [229427] = true,
    [230067] = true,
    [229905] = true,

    -------------
	---- BfA ----
	-------------

    [296142] = true,        -- Shadow Smash (Lost Soul)

	-- Affixes
	[209862] = true,		-- Volcanic Plume (Environment)
	[226512] = true,		-- Sanguine Ichor (Environment)

	-- Freehold
	[272046] = true,		--- Dive Bomb (Sharkbait)
	[257426] = true,		--- Brutal Backhand (Irontide Enforcer)
	[258352] = true,		--- Grapeshot (Captain Eudora)
	[256594] = true,		--- Barrel Smash (Captain Raoul)
	[272374] = true,		--- Whirlpool of Blades (Captain Jolly)
	[256546] = true,		--- Shark Tornado (Trothak)
	[257310] = true,		--- Cannon Barrage (Harlan Sweete)
	[257784] = true,		--- Frost Blast (Bilge Rat Brinescale)
	[257902] = true,		--- Shell Bounce (Ludwig Von Tortollan)
	[258199] = true,		--- Ground Shatter (Irontide Crusher)
	[276061] = true,		--- Boulder Throw (Irontide Crusher)
	[258779] = true,		--- Sea Spout (Irontide Oarsman)
	[274400] = true,		--- Duelist Dash (Cutwater Duelist)
	[257274] = true,		--- Vile Coating (Environment)
	[258673] = true,		--- Azerite Grenade (Irontide Crackshot)
	[274389] = true,		--- Rat Traps (Vermin Trapper)
	[257460] = true,		--- Fiery Debris (Harlan Sweete)

	-- Shrine of the Storm
	[276268] = true,		--- Heaving Blow (Shrine Templar)
	[267973] = true,		--- Wash Away (Temple Attendant)
	[268059] = true,		--- Anchor of Binding (Tidesage Spiritualist)
	[264155] = true,		--- Surging Rush (Aqu'sirr)
	[267841] = true,		--- Blowback (Galecaller Faye)
	[267899] = true,		--- Hindering Cleave (Brother Ironhull)
	[268280] = true,		--- Tidal Pod (Tidesage Enforcer)
	[276286] = true,		--- Slicing Hurricane (Galecaller Apprentice)
	[276292] = true,		--- Whirlign Slam (Ironhull Apprentice)
	[267385] = true,		--- Tentacle Slam (Vol'zith the Whisperer)

	-- Siege of Boralus
	[273718] = true,        --- Heavy Ordnance (Sergeant Bainbridge)
	[256627] = true,		--- Slobber Knocker (Kul Tiran Halberd)
	[256663] = true,		--- Burning Tar (Blacktar Bomber)
	[275775] = true,		--- Savage Tempest (Irontide Raider)
	[257292] = true,		--- Heavy Slash (Kul Tiran Vanguard)
	[272426] = true,		--- Sighted Artillery (Ashvane Spotter)
	[257069] = true,		--- Watertight Shell (Kul Tiran Wavetender)
	[273681] = true,		--- Heavy Hitter (Chopper Redhook)
	[272874] = true,		--- Trample (Ashvane Commander)
	[268260] = true,		--- Broadside (Ashvane Cannoneer)
	[269029] = true,		--- Clear the Deck (Dread Captain Lockwood)
	[268443] = true,		--- Dread Volley (Dread Captain Lockwood)
	[272713] = true,		--- Crushing Slam (Bilge Rat Demolisher)
	[274941] = true,		--- Banana Rampage swirlies(Bilge Rat Buccaneer)
	[257883] = true,		--- Break Water (Hadal Darkfathom)
	[276068] = true,		--- Tidal Surge (Hadal Darkfathom)
	[257886] = true,		--- Brine Pool (Hadal Darkfathom)
	[261565] = true,		--- Crashing Tide (Hadal Darkfathom)
	[277535] = true,		--- Viq'Goth's Wrath (Viq'Goth)

	-- Tol Dagor
	[257119] = true,		--- Sand Trap (The Sand Queen)
	[257785] = true,		--- Flashing Daggers (Jes Howlis)
	[256976] = true,		--- Ignition (Knight Captain Valyri)
	[256955] = true,		--- Cinderflame (Knight Captain Valyri)
	[256083] = true,		--- Cross Ignition (Overseer Korgus)
	[263345] = true,		--- Massive Blast (Overseer Korgus)
	[258364] = true,		--- Fuselighter (Ashvane Flamecaster)
	[259711] = true,		--- Lockdown (Ashvane Warden)
	[256710] = true,		--- Burning Arsenal (Knight Captain Valyri)

	-- Waycrest Manor
	[264531] = true,		--- Shrapnel Trap (Maddened Survivalist)
	[264476] = true,		--- Tracking Explosive (Crazed Marksman)
	[260569] = true,		--- Wildfire (Soulbound Goliath)
	[265407] = true,		--- Dinner Bell (Banquet Steward)
	[264923] = true,		--- Tenderize (Raal the Gluttonous)
	[264712] = true,		--- Rotten Expulsion (Raal the Gluttonous)
	[272669] = true,		--- Burning Fists (Soulbound Goliath)
	[278849] = true,		--- Uproot (Coven Thornshaper)
	[264040] = true,		--- Uprooted Thorns (Coven Thornshaper)
	[265757] = true,		--- Splinter Spike (Matron Bryndle)
	[264150] = true,		--- Shatter (Thornguard)
	[268387] = true,		--- Contagious Remnants (Lord Waycrest)
	[268308] = true,		--- Discordant Cadenza (Lady Waycrest

	-- Atal'Dazar
	[253666] = true,		--- Fiery Bolt (Dazar'ai Juggernaught)
	[257692] = true,		--- Tiki Blaze (Environment)
	[255620] = true,		--- Festering Eruption (Reanimated Honor Guard)
	[258723] = true,		--- Grotesque Pool (Renaimated Honor Guard)
	[250259] = true,		--- Toxic Leap (Vol'kaal)
	[250022] = true,		--- Echoes of Shadra (Yazma)
	[250585] = true, 		--- Toxic Pool (Vol'kaal)
	[250036] = true,		--- Shadowy Remains (Echoes of Shadra)
	[255567] = true,		--- Frenzied Charge (T'lonja)

	-- King's Rest
	[270003] = true,		--- Suppression Slam (Animated Guardian)
	[269932] = true,		--- Ghust Slash (Shadow-Borne Warrior)
	[265781] = true,		--- Serpentine Gust (The Golden Serpent)
	[265914] = true,		--- Molten Gold (The Golden Serpent)
	[270928] = true,		--- Bladestorm (King Timalji)
	[270931] = true,		--- Darkshot (Queen Patlaa)
	[270891] = true,		--- Channel Lightning (King Rahu'ai)
	[266191] = true,		--- Whirling Axe (Council of Tribes)
	[270292] = true,		--- Purifying Flame (Purification Construct)
	[270503] = true,		--- Hunting Leap (Honored Raptor)
	[270514] = true,		--- Ground Crush (Spectral Brute)
	[271564] = true,		--- Embalming Fluid (Embalming Fluid)
	[270485] = true,		--- Blooded Leap (Spectral Berserker)
	[267639] = true,		--- Burn Corruption (Mchimba the Embalmer)
	[268419] = true,		--- Gale Slash (King Dazar)
	[268796] = true,		--- Impaling Spear (King Dazar)

	-- The MOTHERLODE!!
	[257371] = true,		--- Gas Can (Mechanized Peace Keeper)
	[262287] = true,		--- Concussion Charge (Mech Jockey / Venture Co. Skyscorcher)
	[268365] = true,		--- Mining Charge (Wanton Sapper)
	[269313] = true,		--- Final Blast (Wanton Sapper)
	[275907] = true,		--- Tectonic Smash (Azerokk)
	[259533] = true,		--- Azerite Catalyst (Rixxa Fluxflame)
	[260103] = true,		--- Propellant Blast (Rixxa Fluxflame)
	[260279] = true,		--- Gattling Gun (Mogul Razdunk)
	[276234] = true, 		--- Micro Missiles (Mogul Razdunk)
	[270277] = true,		--- Big Red Rocket (Mogul Razdunk)
	[271432] = true,		--- Test Missile (Venture Co. War Machine)
	[257337] = true,		--- Shocking Claw (Coin-Operated Pummeler)
	[268417] = true,		--- Power Through (Azerite Extractor)
	[268704] = true,		--- Furious Quake (Stonefury)
	[258628] = true,		--- Resonant Quake (Earthrager)
	[269092] = true,		--- Artillery Barrage (Ordnance Specialist)
	[271583] = true,		--- Black Powder Special (Mines near the track)
	[269831] = true,		--- Toxic Sludge (Oil Environment)

	-- Temple of Sethraliss
	[263425] = true,		--- Arc Dash (Adderis)
	[268851] = true,		--- Lightning Shield (Aspix and Adderis)
	[263573] = true,		--- Cyclone Strike (Adderis)
	[273225] = true,		--- Volley (Sandswept Marksman)
	[272655] = true,		--- Scouring Sand (Mature Krolusk)
	[273995] = true,		--- Pyrrhic Blast (Crazed Incubator)
	[272696] = true,		--- Lightning in a Bottle (Crazed Incubator)
	[264206] = true,		--- Burrow (Merektha)
	[272657] = true,		--- Noxious Breath (Merektha)
	[272821] = true,		--- Call Lightning (Imbued Stormcaller)
	[264763] = true,		--- Spark (Static-charged Dervish)
	[279014] = true,		--- Cardiac Shock (Avatar, Environment)

	-- Underrot
	[265542] = true,		--- Rotten Bile (Fetid Maggot)
	[265019] = true,		--- Savage Cleave (Chosen Blood Matron)
	[261498] = true,		--- Creeping Rot (Elder Leaxa)
	[264757] = true,		--- Sanguine Feast (Elder Leaxa)
	[265665] = true,		--- Foul Sludge (Living Rot)
	[260312] = true,		--- Charge (Cragmaw the Infested)
	[265511] = true,		--- Spirit Drain (Spirit Drain Totem)
	[259720] = true,		--- Upheaval (Sporecaller Zancha)
	[270108] = true,		--- Rotting Spore (Unbound Abomination)
	[272609] = true,		--- Maddenin Gaze (Faceless Corruptor)
	[272469] = true,		--- Abyssal Slam (Faceless Corruptor)
	[270108] = true,		--- Rotting Spore (Unbound Abomination)

	-- Mechagon Workshop
	[294128] = true,		--- Rocket Barrage (Rocket Tonk)
	[285020] = true,		--- Whirling Edge (The Platinum Pummeler)
	[294291] = true,		--- Process Waste ()
	[291930] = true,		--- Air Drop (K.U-J.0)
	[294324] = true,		--- Mega Drill (Waste Processing Unit)
	[293861] = true,		--- Anti-Personnel Squirrel (Anti-Personnel Squirrel)
	[295168] = true,		--- Capacitor Discharge (Blastatron X-80)
	[294954] = true,		--- Self-Trimming Hedge (Head Machinist Sparkflux)
    [293827] = true,
    [293986] = true,


	-- Mechagon Junkyard
	[300816] = true,		--- Slimewave (Slime Elemental)
	[300188] = true,		--- Scrap Cannon (Weaponized Crawler)
	[300427] = true,		--- Shockwave (Scrapbone Bully)
	[294890] = true,		--- Gryro-Scrap (Malfunctioning Scrapbot)
	[300129] = true,		--- Self-Destruct Protocol (Malfunctioning Scrapbot)
	[300561] = true,		--- Explosion (Scrapbone Trashtosser)
	[299475] = true,		--- B.O.R.K. (Scraphound)
	[299535] = true,		--- Scrap Blast (Pistonhead Blaster)
	[298940] = true,		--- Bolt Buster (Naeno Megacrash)
	[297283] = true,		--- Cave In (King Gobbamak)

	--- Awakened Lieutenant
	[314309] = true,		--- Dark Fury (Urg'roth, Breaker of Heroes)
	[314467] = true,		--- Volatile Rupture (Voidweaver Mal'thir)
	[314565] = true,		--- Defiled Ground (Blood of the Corruptor)

	---------------------
	---- SHADOWLANDS ----
	---------------------

    -- Affixes
    [209862] = true, -- Volcanic Plume
    [343520] = true, -- Storming
    [226512] = true, -- Sanguine Ichor (Environment)
    [240448] = true, -- Quaking (Environment)
    [342494] = true, -- Belligerent Boast (Season 1 Prideful)
    [-174773] = true, -- Spiteful Shade Melee Damage
    [350163] = true, -- Spiteful Shade Melee Damage
    [240446] = true, -- Explosion
    [356414] = true, -- Frost Lance (Season 2)
    [355806] = true, -- Massive Smash (Season 2)
    [355737] = true, -- Scorching Blast (Season 2)
    [358967] = true, -- Inferno (Season 2)
    [358897] = true, -- Cold Snap (Season 2)
    [366409] = true, -- Fusion Beam (Season 3)
    [366288] = true, -- Force Slam (Season 3)
    [366566] = true, -- Burst (Season 3)
    [373429] = true, -- Season 4
    [373513] = true, -- Season 4

    -- Plaguefall
    [319898] = true, -- Vile Spit (Slime Tentacle)
    [328501] = true, -- Plague Bomb (Rigged Plagueborer)
    [322475] = true, -- Plague Crash (Margrave Stradama adds)
    [322358] = true, -- Burning Strain (Doctor Ickus)
    [318949] = true, -- Festering Belch (Blighted Spinebreaker)
    [330404] = true, -- Wing Buffet
    [328395] = true, -- Venompiercer (Venomous Sniper)
    [328986] = true, -- Violent Detonation (Unstable Canister)
    [322410] = true, -- Withering Filth (Congealed Slime)
    [327233] = true, -- Belch Plague (Plaguebelcher)
    [319120] = true, -- Putrid Bile
    [344001] = true, -- Slime Trail
    [320072] = true, -- Toxic Pool (Decaying Flesh Giant)
    [328177] = true, -- Fungistorm (Fungi Stormer)
    [326242] = true, -- Slime Wave (Globgrog)
    [329217] = true, -- Slime Lunge (Doctor Ickus) -- TODO find out which one is correct
    [329215] = true, -- Slime Lunge (Doctor Ickus)
    [329163] = true, -- Ambush (Stealthlings)
    [330135] = true, -- Fount of Pestilence (Margrave Stradama DoT in her pool)
    [320519] = true, -- Jagged Spines (Blighted Spinebreaker)
    [324667] = true, -- Slime Wave (Globgrog)
    [626242] = true, -- Slime Wave (Globgrog)
    [333808] = true, -- Oozing Outbreak (Doctor Ickus)
    [322492] = true, -- Plague Rot (Margrave Stradama)
    [321406] = true, -- Virulent Explosion (Doctor Ickus add)
    -- The Necrotic Wake
    [345625] = true, -- Death Burst (Nar'zudah <Servant of Amarth>)
    [320574] = true, -- Shadow Well
    [324391] = true, -- Frigid Spikes
    [327952] = true, -- Meat Hook
    [320614] = true, -- Blood Gorge (Carrion Worm)
    [334749] = true, -- Drain Fluids
    [320784] = true, -- Comet Storm (Nalthor the Rimebinder)
    [328212] = true, -- Razorshard Ice
    [324381] = true, -- Chill Scythe
    [327100] = true, -- Noxious Fog
    [333489] = true, -- Necrotic Breath
    [333492] = true, -- Necrotic Ichor
    [333477] = true, -- Gut Slice (Goregrind)
    [320365] = true, -- Embalming Ichor (Surgeon Stitchflesh)
    [320366] = true, -- Embalming Ichor (Surgeon Stitchflesh)
    [338353] = true, -- Goresplatter (Corpse Collector)
    [319902] = true, -- Land of the Dead
    -- Spires of Ascension
    [327413] = true, -- Rebellious Fist (Forsworn Goliath)
    [336444] = true, -- Crescendo
    [317626] = true, -- Maw-Touched Venom
    [324141] = true, -- Dark Bolt
    [317963] = true, -- Burden of Knowledge (Forsworn Castigator)
    [324370] = true, -- Attenuated Barrage (Azules)
    [331251] = true, -- Deep Connection (Kin-Tara)
    [324662] = true, -- Ionized Plasma (Kin-Tara)
    [323792] = true, -- Anima Field (Coalesced Anima)
    [323372] = true, -- Empyreal Ordnance
    [323943] = true, -- Run Through (Devos)
    [323786] = true, -- Swift Slice (Kyrian Dark-Praetor)
    [317943] = true, -- Sweeping Blow (Frostsworn Vanguard)
    [324608] = true, -- Charged Stomp (Oryphrion)
    [323740] = true, -- Impact (Forsworn Squad-Leader)
    [336447] = true, -- Crashing Strike (Forsworn Squad-Leader)
    [328466] = true, -- Charged Spear (Lakesis / Klotos)
    [336420] = true, -- Diminuendo (Klotos / Lakesis)
    [321034] = true, -- Charged Spear (Kin-Tara)
    [324141] = true, -- Dark Bolt (Ventunax)
    [323943] = true, -- Run Through (Devos)
    -- Mists of Tirna Scithe
    [326309] = true, -- Decomposing Acid
    [326017] = true, -- Decomposing Acid
    [321828] = true, -- Patty Cake (Mistcaller)
    [321893] = true, -- Freezing Burst (Freezing Burst)
    [336759] = true, -- Dodge Ball (Mistcaller)
    [321834] = true, -- Dodge Ball (Mistcaller)
    [322655] = true, -- Acid Expulsion
    [324923] = true, -- Bramble Burst (Drust Boughbreaker)
    [321837] = true, -- Oopsie (Mistcaller)
    [321968] = true, -- Bewildering Pollen (tirnenn Villager)
    [323137] = true, -- Bewildering Pollen (tirnenn Villager)
    [323250] = true, -- Anima Puddle (Droman Oulfarran)
    [326022] = true, -- Acid Globule (Spinemaw Gorger)
    [340300] = true, -- Tongue Lashing (Mistveil Gorgegullet)
    [340304] = true, -- Poisonous Secretions (Mistveil Gorgegullet)
    [331743] = true, -- Bucking Rampage (Mistveil Guardian)
    [326263] = true, -- Anima Shedding (Tred'ova)
    [325027] = true, -- Bramble Burst (Drust Boughbreaker)
    -- Theater of Pain
    [320180] = true, -- Noxious Spores (Paceran the Virulent)
    [339415] = true, -- Deafening Crash (Xav the Unfallen)
    [321041] = true, -- Disgusting Burst
    [333297] = true, -- Death Winds
    [332708] = true, -- Ground Smash (Heavin the Breaker)
    [318406] = true, -- Tenderizing Smash (Gorechop)
    [337037] = true, -- Whirling Blade (Nekthara the Mangler)
    [331243] = true, -- Bone Spikes (Soulforged Bonereaver)
    [331224] = true, -- Bonestorm (Soulforged Bonereaver)
    [330608] = true, -- Vile Eruption (Rancind Gasbag)
    [317231] = true, -- Crushing Slam (Xav the Unfallen)
    [320729] = true, -- Massive Cleave (Xav the Unfallen)
    [323681] = true, -- Dark Devastation (Mordretha)
    [339573] = true, -- Echos of Carnage (Mordretha)
    [339759] = true, -- Echos of Carnage (Mordretha)
    [339751] = true, -- Ghostly Charge (Mordretha)
    [341969] = true, -- Withering Discharge (Blighted Sludge-Spewer)
    [317367] = true, -- Necrotic Volley
    -- Halls of Atonement
    [323001] = true, -- Glass Shards (Halkias)
    [324044] = true, -- Refracted Sinlight
    [323126] = true, -- Telekinetic Collision
    [325523] = true, -- Deadly Thrust (Depraved Darkblade)
    [325799] = true, -- Rapid Fire (Depraved Houndmaster)
    [326440] = true, -- Sin Quake (Shard of Halkias)
    [322945] = true, -- Heave Debris (Halkias)
    [319702] = true, -- Blood Torrent (Echelon)
    [329113] = true, -- Telekinteic Onslaught (Lord Chamberlain)
    [327885] = true, -- Erupting Torment (Lord Chamberlain)
    [323414] = true, -- Ritual of Woe (Lord Chamberlain)
    -- De Other Side
    [342961] = true, -- Localized Explosive Contrivance (Dealer Xy'exa)
    [320232] = true, -- Explosive Contrivance (Dealer Xy'exa)
    [325691] = true, -- Cosmic Collapse
    [320723] = true, -- Displaced Blastwave (Dealer Xy'exa)
    [323136] = true, -- Anima Starstorm
    [345498] = true, -- Anima Starstorm
    [334913] = true, -- Master of Death (Mueh'zala)
    [328729] = true, -- Dark Lotus
    [332729] = true, -- Malefic Blast
    [333250] = true, -- Reaver (Risen Warlord)
    [331933] = true, -- Haywire
    [331398] = true, -- Volatile Capacitor (Volatile Memory)
    [323118] = true, -- Blood Barrage (Hakkar the Soulflayer)
    [332672] = true, -- Bladestorm
    [334051] = true, -- Erupting Darkness (Death Speaker)
    [342869] = true, -- Enraged Mask (Enraged Spirit)
    [333790] = true, -- Enraged Mask (Enraged Spirit)
    [323569] = true, -- Spilled Essence (Environement)
    [320830] = true, -- Mechanical Bomb Squirrel
    [327427] = true, -- Shattered Dominion (Mueh'zala)
    [335000] = true, -- Stellar cloud (Mueh'zala)
    [334961] = true, -- Crush (Mueh'zala)
    [324010] = true, -- Eruption (Manastorm)
    [320804] = true, -- Experimental Squirrel Bomb (Manastorm add)
    -- Sanguine Depths
    [320999] = true, -- Echoing Thrust (Regal Mistdancer)
    [320991] = true, -- Echoing Thrust (Regal Mistdancer)
    [322418] = true, -- Craggy Fracture
    [323573] = true, -- Residue
    [322212] = true, -- Growing Mistrust (Vestige of Doubt)
    [334563] = true, -- Volatile Trap
    [334615] = true, -- Sweeping Slash
    [325885] = true, -- Anguished Cries (Z'rali)
    [328494] = true, -- Sintouched Anima
    [323810] = true, -- Piercing Blur (General Kaal)
    [336277] = true, -- Explosive Anger (Remnant of Fury)
    [334563] = true, -- Volatile Trap (Dreadful Huntmaster)
    [320991] = true, -- Echoing Thrust (Regal Mistdancer)
    [320999] = true, -- Echoing Thrust (Regal Mistdancer Mirror)
    [334921] = true, -- Umbral Crash (Insatiable Brute)
    [322418] = true, -- Craggy Fracture (Chamber Sentinel)
    [334378] = true, -- Explosive Vellum (Research Scribe)
    [323573] = true, -- Residue (Fleeting Manifestation)
    [325885] = true, -- Anguished Cries (Z'rali)
    [334615] = true, -- Sweeping Slash (Head Custodian Javlin)
    [322212] = true, -- Growing Mistrust (Vestige of Doubt)
    [328494] = true, -- Sintouched Anima (Environement)
    [323810] = true, -- Piercing Blur (General Kaal)
    -- Tazavesh: So'leah's Gambit
    [346828] = true, -- Sanitizing Field (Hylbrande)
    [347094] = true, -- Titanic Crash (Hylbrande)
    [347149] = true, -- Infinite Breath (Timecap'n Hooktail)
    [347151] = true, -- Hook Swipe (Timecap'n Hooktail)
    [351119] = true, -- Shuriken Blitz (So' Cartel Assassin)
    [351646] = true, -- Hyperlight Nova
    [354334] = true, -- Hook'd! (Timecap'n Hooktail)
    [355465] = true, -- Boulder Throw (Coastwalker Goliath)
    [355581] = true, -- Crackle
    [355584] = true, -- Charged Pulse (Stormforged Guardian)
    [357260] = true, -- Unstable Rift (Focused Ritualist)
    [358947] = true, -- Burning Tar (Hourglass Cannon)
    [357228] = true, -- Drifting Star (Adorned Starseer)
    [356260] = true, -- Tidal Burst (Hourglass Tidesage)
    [346960] = true, -- Tidal Burst (Hourglass Tidesage)
    -- Tazavesh: Streets of Wonder
    [346028] = true, -- Interrogation
    [347481] = true, -- Shuri (So'azmi)
    [349663] = true, -- Grip of Hunger (Alcruux)
    [350090] = true, -- Whirling Annihilation
    [350921] = true, -- Crowd Control
    [350922] = true, -- Menacing Shout
    [351070] = true, -- Venting Concussion
    [353835] = true, -- Suppression (Disruptive Patron)
    [355476] = true, -- Shock Mines (Commander Zo'far)
    [355641] = true, -- Scintillate (Veteran Sparkcaster)
    [356011] = true, -- Beam Splicer
    [355903] = true, -- Disruption Grenade
    [356482] = true, -- Rotten Food
    [356404] = true, -- Lava Breath (Ancient Core Hound)
};

local SpellsNoTank = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks
    [165122] = true,
    [161256] = true,
    [162281] = true,
    [164734] = true,
    [167095] = true,
    [167120] = true,
    [167233] = true,
    [167815] = true,
    [169413] = true,
    [178411] = true,

    -- Grimrail Depot
    [164218] = true,
    [164163] = true,
    [163536] = true,
    [176039] = true,
    [161089] = true,
    [164102] = true,
    [164188] = true,
    [176033] = true,

    ----------------
    ---- LEGION ----
    ----------------

    -- Black Rock Hold
    [198635] = true,        -- Unerring Shear
    [200084] = true,        -- Soul Blade
    [201141] = true,        -- Brutal Assault
    [214003] = true,        -- Coup de Grace
    [225909] = true,        -- Soul Venom

    -- Court of Stars
    [209036] = true,        -- Throw Torch
    [211473] = true,        -- Shadow Slash

    -- Darkheart Thicket
    [198376] = true,        -- Primal Rampage
    [200289] = true,        -- Growing Paranoia
    [200589] = true,        -- Festering Swipe
    [204611] = true,        -- Crushing Grip

    -- Eye of Azshara
    [192135] = true,        -- Bellowing Roar (Hatecoil Shellbreaker)
    [195094] = true,        -- Coral Slash (Hatecoil Warrior)
    [195172] = true,        -- Mighty Slam (Hatecoil Crusher)
    [196060] = true,        -- Numbing Toxin
    [196058] = true,        -- Lethargic Toxin
    [196064] = true,        -- Tearing Bite
    [196111] = true,        -- Jagged Claws

    -- Neltharion's Lair
    [198496] = true,        -- Sunder
    [200732] = true,        -- Molten Crash

    -- Vault of the Wardens
    [191540] = true,        -- Strike
    [361313] = true,        -- Leeching Bite
    [363073] = true,        -- Darkstrikes

    -- Karazhan Lower
    [228603] = true,
    [228995] = true,
    [227493] = true,
    [228986] = true,
    [227339] = true,
    [227636] = true,
    [238566] = true,
    [227638] = true,
    [241774] = true,
    [228252] = true,
    [228252] = true,
    [241809] = true,
    [228637] = true,
    [228396] = true,
    [29581] = true,
    [29930] = true,
    [29665] = true,
    [29667] = true,
    [227965] = true,
    [227568] = true,
    [227799] = true,

    -- Karazhan Upper
    [230050] = true,
    [230161] = true,
    [230002] = true,


    -------------
    ---- BfA ----
    -------------

    -- Freehold

	-- Shrine of the Storm

	-- Siege of Boralus
	[268230] = true,		--- Crimson Swipe (Ashvane Deckhand)

	-- Tol Dagor
	[258864] = true,		--- Suppression Fire (Ashvane Marine/Spotter)

	-- Waycrest Manor
	[263905] = true,		--- Marking Cleave (Heartsbane Runeweaver)
	[265372] = true,		---	Shadow Cleave (Enthralled Guard)
	[271174] = true,		--- Retch (Pallid Gorger)

	-- Atal'Dazar

	-- King's Rest
	[270289] = true,		--- Purification Beam (Purification Construct)

	-- The MOTHERLODE!!
	[268846] = true,		--- Echo Blade (Weapons Tester)
	[263105] = true,		--- Blowtorch (Feckless Assistant)
	[263583] = true,		--- Broad Slash (Taskmaster Askari)

	-- Temple of Sethraliss
	[255741] = true,		--- Cleave (Scaled Krolusk Rider)

	-- Underrot
	[272457] = true,		--- Shockwave (Sporecaller Zancha)
	[260793] = true,		--- Indigestion (Cragmaw the Infested)

	---------------------
	---- SHADOWLANDS ----
	---------------------

    -- Plaguefall
    [330403] = true, -- Wing Buffet (Plaguerocs)
    [330417] = true, -- Mighty Swing (Mire Soldier)
    [322239] = true, -- Touch of Slime (Malignant Spawn)
    [330417] = true, -- Mighty Swing (Mire Soldier)
    [325550] = true, -- Venomblades (Domina Venomblade)
    [327882] = true, -- Blightbeak (Plagueroc)
    [328094] = true, -- Pestilence Bolt
    [329110] = true, -- Slime Injection (Doctor Ickus)
    [335863] = true, -- Nibble (Creepy Crawler)
    [328342] = true, -- Venomfangs
    [334926] = true, -- Wretched Phlegm (Rigged Plagueborer)
    [325552] = true, -- Cytotoxic Slash (Cytotoxic Slash)
    -- The Necrotic Wake
    [320771] = true, -- Icy Shard (Nalthor the Rimebinder)
    [338456] = true, -- Mutlilate
    [321807] = true, -- Boneflay (Zolramus Bonecarver)
    [320580] = true, -- Melee
    [324323] = true, -- Gruesome Cleave
    [320696] = true, -- Bone Claw
    [338357] = true, -- Tenderize
    [334488] = true, -- Sever Flesh (Surgeon Stitchflesh)
    [333477] = true, -- Gut Slice (Goregrind)
    [320655] = true, -- Crunch (Blightbone)
    [324394] = true, -- Shatter (Skeletal Monstrosity)
    [338636] = true, -- Separate Flesh (Separation Assistant)
    [338653] = true, -- Throw Flesh (Stitching Assistant)
    [320366] = true, -- Embalming Ichor (Surgeon Stitchflesh)
    -- Spires of Ascension
    [320966] = true, -- Overhead Slash (Kin-Tara)
    [317943] = true, -- Sweeping Blow (Forsworn Vanguard)
    [324608] = true, -- Charged Stomp (Oryphrion)
    [328289] = true, -- Blessed Weapon
    [323786] = true, -- Swift Slice (Kyrian Dark-Praetor)
    [327331] = true, -- Imbued Weapon
    [317661] = true, -- Insidious Venom (Etherdiver)
    [336444] = true, -- Crescendo (Forsworn Helion)
    -- Mists of Tirna Scithe
    [322557] = true, -- Soul Split
    [323057] = true, -- Spirit Bolt (Ingra Maloch)
    [331721] = true, -- Spear Flurry (Mistveil Defender)
    [331748] = true, -- Back Kick
    -- Theater of Pain
    [326835] = true, -- Cruel Slash (Ossified Conscript)
    [324079] = true, -- Reaping Scythe (Mordretha, the Endless Empress)
    [323515] = true, -- Hateful Strike (Gorechop)
    [330875] = true, -- Spirit Frost (Nefarious Darkspeaker)
    [331319] = true, -- Savage Flurry
    [331320] = true, -- Savage Flurry
    [337178] = true, -- Vicious Strike (Unyielding Contender)
    [324424] = true, -- Reaping Scythe (Mordretha, the Endless Empress)
    [318102] = true, -- Finishing Blow
    [316995] = true, -- Quick Strike
    [331288] = true, -- Colossus Smash (Heavin the Breaker)
    [320063] = true, -- Slam (Dessia the Decapitator)
    [330565] = true, -- Shield Bash (Ancient Captain)
    -- Halls of Atonement
    [344993] = true, -- Jagged Swipe (Vicious Gargon)
    [329321] = true, -- Jagged Swipe (Vicious Gargon)
    [338003] = true, -- Wicked Bolt (Depraved Obliterator)
    [329324] = true, -- Jaws of Stone (Vicious Gargon)
    [326997] = true, -- Powerful Swipe (Stoneborn Slasher)
    [326829] = true, -- Wicked Bolt (Inquisitor Sigar)
    [323437] = true, -- Stigma of Pride (Lord Chamberlain)
    [322936] = true, -- Crumbling Slam (Halkias)
    [323538] = true, -- Bolt of Power (High Adjudicator Aleez)
    [338004] = true, -- Bonk (Toiling Groundskeeper)
    [346866] = true, -- Stone Breathe (Loyal Stoneborn)
    -- De Other Side
    [333711] = true, -- Decrepit Bite (Skeletal Raptor)
    [333728] = true, -- Bonestrike (Risen Bonesoldier)
    [340016] = true, -- Talon Rake (Mythresh, Sky's Talons)
    [334535] = true, -- Beak Slice
    [327649] = true, -- Crushed Soul (Mueh'zala)
    [327646] = true, -- Soulcrusher (Mueh'zala)
    [320147] = true, -- Bleeding (Millificent Manastorm)
    [320145] = true, -- Buzz-Saw
    [328707] = true, -- Scribe (Risen Cultist)
    [331548] = true, -- Metallic Jaws (4.RF-4.RF)
    [322735] = true, -- Piercing Barb (Hakkar the Soulflayer)
    [322736] = true, -- Piercing Barb (Hakkar the Soulflayer)
    [332678] = true, -- Gushing Wound (Atal'ai Deathwalker)
    [332705] = true, -- Smite (Atal'ai High Priest)
    -- Sanguine Depths
    [322429] = true, -- Severing Slice (Chamber Sentinel)
    [320843] = true, -- Thrash
    [321178] = true, -- Slam (Insatiable Brute)
    [335308] = true, -- Crushing Strike (Depths Warden)
    [319650] = true, -- Vicious Headbutt (Kryxis the Voracious)
    [321264] = true, -- Claw (Rockbound Sprite)
    [326718] = true, -- Pierce (Sanguine Cadet)
    [325257] = true, -- Iron Spikes
    [325260] = true, -- Iron Spikes
    [325261] = true, -- Iron Spikes
    [325262] = true, -- Iron Spikes
    [334326] = true, -- Bludgeoning Bash (Head Custodian Javlin)
    [316068] = true, -- Bonk
    [326952] = true, -- Fiery Cantrip (Infused Quill-feather)
    [316244] = true, -- Animate Pebble
    -- Tazavesh: So'leah's Gambit
    [355225] = true, -- Waterbolt (Murkbrine Fishmancer)
    [357281] = true, -- Energy Slash (Devoted Accomplice)
    [366297] = true, -- Deconstruct (Urh Dismantler)
    [356843] = true,
    [355048] = true,
    [368662] = true,
    [346877] = true,
    -- Tazavesh: Streets of Wonder
    [347635] = true, -- Energy Star (So'azmi)
    [347636] = true, -- Energy Star
    [347716] = true, -- Letter Opener (P.O.S.T. Worker)
    [348008] = true, -- Postage Stamp (P.O.S.T. Worker)
    [350916] = true, -- Security Slam (Oasis Security)
    [352796] = true, -- Proxy Strike
    [354297] = true, -- Hyperlight Bolt
    [355644] = true, -- Hyperlight Salvo
    [356967] = true, -- Hyperlight Backhand (Cartel Muscle)
    [359028] = true, -- Security Slam (Zo'gron)

    -- AFFIXES
    [373364] = true, -- Vampiric Claws (Season 4)
    [373509] = true, -- Season 4
};

local Auras = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks
    [163390] = true,
    [164504] = true,
    [172636] = true,

    -- Grimrail Depot
    [166340] = true,

    ----------------
    ---- LEGION ----
    ----------------

    -- Black Rock Hold
    [194960] = true,        -- Soul Echoes
    [197546] = true,        -- Brutal Glaive

    -- Court of Stars

    -- Darkheart Thicket

    -- Eye of Azshara
    [192053] = true,        -- Quicksand
    [196515] = true,        -- Magic Binding

    -- Neltharion's Lair

    -- Vault of the Wardens

    -- Karazhan Lower

    -- Karazhan Upper

    -------------
    ---- BfA ----
    -------------

    -- Freehold
	[274516] = true,		-- Slippery Suds

	-- Shrine of the Storm
	[268391] = true,		-- Mental Assault (Abyssal Cultist)
	[269104] = true,		-- Explosive Void (Lord Stormsong)
	[267956] = true,		-- Zap (Jellyfish)

	-- Siege of Boralus
	[274942] = true,		-- Banana Stun
	[257169] = true,		-- Fear

	-- Tol Dagor
	[256474] = true,		-- Heartstopper Venom (Overseer Korgus)

	-- Waycrest Manor
	[265352] = true,		-- Toad Blight (Toad)
	[278468] = true,		-- Freezing Trap

	-- Atal'Dazar
	[255371] = true,		-- Terrifying Visage (Rezan)

	-- King's Rest
	[276031] = true,		-- Pit of Despair (Minion of Zul)

	-- Temple of Sethraliss
	[269970] = true,		-- Blinding Sand (Merektha)

	-- Underrot

	-- The MOTHERLODE!!
	[280605] = true,        -- Brain Freeze (Refreshment Vendor)

	-- Mechagon Workshop
	[293986] = true,		--- Sonic Pulse (Blastatron X-80)

	-- Mechaton Junkyard
	[398529] = true,		-- Gooped (Gunker)
	[300659] = true,		-- Consuming Slime (Toxic Monstrosity)

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- Affixes
    [342494] = true, -- Belligerent Boast (Manifestation of Pride)
    -- Plaguefall
    [336301] = true, -- Web Wrap (Domina Venomblade)
    [333406] = true, -- Assassinate (Domina Venomblade adds)
    [344001] = true, -- Slime Trail
    [322358] = true, -- Burning Strain (Doctor Ickus)
    [319898] = true, -- Vile Spit (Slime Tentacle)
    [319120] = true, -- Putrid Bile
    [328501] = true, -- Plague Bomb (Rigged Plagueborer)
    [320512] = true, -- Corroded Claws (Rotting Slimeclaw)
    -- The Necrotic Wake
    [322681] = true, -- Meat Hook (Stitchflesh's Creation)
    [333492] = true, -- Necrotic Ichor
    [334748] = true, -- Drain Fluids
    [320573] = true, -- Shadow Well (Zolramus Sorcerer)
    [320366] = true, -- Embalming Ichor (Surgeon Stitchflesh)
    [333489] = true, -- Necrotic Breath
    [327100] = true, -- Noxious Fog
    [324293] = true, -- Rasping Scream
    -- Spires of Ascension
    [317963] = true, -- Burden of Knowledge (Forsworn Castigator)
    [317626] = true, -- Maw-Touched Venom
    [323739] = true, -- Residual Impact
    [331251] = true, -- Deep Connection (Kin-Tara)
    [323792] = true, -- Anima Field (Coalesced Anima)
    -- Mists of Tirna Scithe
    [325027] = true, -- Bramble Burst (Drust Boughbreaker)
    [326309] = true, -- Decomposing Acid
    [321828] = true, -- Patty Cake (Mistcaller)
    [326017] = true, -- Decomposing Acid
    [321893] = true, -- Freezing Burst (Illusionary Vulpin)
    [323137] = true, -- Bewildering Pollen (Drohman Oulfarran)
    [324859] = true, -- Bramblethorn Entanglement
    -- Halls of Atonement
    [319703] = true, -- Blood Torrent (Echelon)
    [339237] = true, -- Sinlight Visions (Echelon)
    -- De Other Side
    [331379] = true, -- Lubricate (Lubricator)
    [323118] = true, -- Blood Barrage (Hakkar the Soulflayer)
    [333250] = true, -- Reaver (Risen Warlord)
    [334913] = true, -- Master of Death (Mueh'zala)
    -- Sanguine Depths
    [321038] = true, -- Wrack Soul (Wicked Oppressor)
    [326836] = true, -- Curse of Suppression (Wicked Oppressor)
    [322212] = true, -- Growing Mistrust (Vestige of Doubt)
    -- Theater of Pain
    [341949] = true, -- Withering Blight
    [323831] = true, -- Death Grasp
    -- Tazavesh: Streets of Wonder
    [346297] = true, -- Unstable Explosion
    [346329] = true, -- Spilled Liquids
    [347728] = true, -- Flock!

    -- Affixes
    [373391] = true, -- Season 4
};

local AurasNoTank = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks

    -- Grimrail Depot
    [164241] = true,


    ----------------
    ---- LEGION ----
    ----------------

    -- Black Rock Hold

    -- Court of Stars

    -- Darkheart Thicket

    -- Eye of Azshara
    [195094] = true,        -- Coral Slash

    -- Neltharion's Lair

    -- Vault of the Wardens

    -- Karazhan Lower
    [227493] = true,
    [241774] = true,
    [29574] = true,
    [230297] = true,
    [227832] = true,

    -- Karazhan Upper

    -------------
    ---- BfA ----
    -------------

    [272140] = true,		--- Iron Volley

    ---------------------
	---- SHADOWLANDS ----
	---------------------

    -- Plaguefall
    [325552] = true, -- Cytotoxic Slash (Domina Venomblade)
    [327882] = true, -- Blightbeak (Plagueroc)
    -- The Necrotic Wake
    [338357] = true, -- Tenderize
    [321807] = true, -- Boneflay (Zolramus Bonecarver)
    [333477] = true, -- Gut Slice (Goregrind)
    -- Halls of Atonement
    [344993] = true, -- Jagged Swipe (Vicious Gargon)
    [326632] = true, -- Stony Veins
    -- Sanguine Depths
    [322429] = true, -- Severing Slice (Chamber Sentinel)
};

local SpellsToInterrupt = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks
    [165122] = true,
    [178154] = true,

    -- Grimrail Depot
    [164192] = true,
    [166335] = true,
    [163966] = true,


    ----------------
    ---- LEGION ----
    ----------------

    -- Affix
    [360857] = true,        -- Battle Frenzy (Infernal)
    [360909] = true,        -- Eye Beam (Infernal)

    -- Black Rock Hold
    [196883] = true,        -- Spirit Blast (Lord Etheldrin Ravencrest)
    [197797] = true,        -- Arcane Blitz (Risen Arcanist)
    [200248] = true,        -- Arcane Blitz
    [225573] = true,        -- Dark Mending (Ghostly Councilor)
    [227913] = true,        -- Felfrenzy (Felspite Dominator)

    -- Court of Stars
    [208165] = true,        -- Withering Soul (Talixae Flamewreath)
    [209404] = true,        -- Seal Magic (Duskwatch Arcanist)
    [209413] = true,        -- Suppress
    [209485] = true,        -- Drain Magic (Arcane Manifestation)
    [210261] = true,        -- Sound Alarm (Duskwatch Reinforcement)
    [211299] = true,        -- Searing Glare (Watchful Inquisitor)
    [211470] = true,        -- Bewitch (Shadow Mistress)
    [215204] = true,        -- Hinder (Vigilant Duskwatch)
    [225100] = true,        -- Charging Station (Guardian Construct)

    -- Darkheart Thicket
    [200630] = true,        -- Unnerving Screech (Mindshattered Screecher)
    [200658] = true,        -- Star Shower
    [201298] = true,        -- Bloodbolt (Bloodtainted Burster)
    [204243] = true,        -- Tormenting Eye (Nightmare Dweller)

    -- Eye of Azshara
    [192003] = true,        -- Blazing Nova
    [192135] = true,        -- Bellowing Roar
    [195046] = true,        -- Rejuvenating Waters
    [195129] = true,        -- Thundering Stomp
    [196175] = true,        -- Armorshell
    [196870] = true,        -- Storm

    -- Neltharion's Lair
    [193585] = true,        -- Bound (Rockbound Trapper)
    [202181] = true,        -- Stone Gaze

    -- Vault of the Wardens
    [193069] = true,        -- Nightmares (Felsworn Infester)

    -- Karazhan Lower
    [227542] = true,
    [228606] = true,
    [227987] = true,
    [228254] = true,
    [227800] = true,
    [227823] = true,
    [227616] = true,
    [232115] = true,
    [228025] = true,
    [241784] = true,
    [228279] = true,
    [29580] = true,
    [227545] = true,

    -- Karazhan Upper

    -------------
    ---- BfA ----
    -------------

    -- AD
	[256849] = true, -- Dino Might
	[253583] = true, -- Fiery Enchant
	[253517] = true, -- Mending Word
	[255041] = true, -- Terrifying Screech
	[279118] = true, -- Unstable Hex
	-- FH
	[267433] = true, -- Activate Mech
	[257397] = true, -- Healing Balm
	[258777] = true, -- Sea Spout
	[257732] = true, -- Shattering Bellow
	[257736] = true, -- Thundering Squall
	-- KR
	[270901] = true, -- Induce Regeneration
	[270492] = true, -- Hex
	[267273] = true, -- Poison Nova
	[269972] = true, -- Shadow Bolt Volley
	[267763] = true, -- Wretched Discharge
	-- MH JY
	[300436] = true, -- Grasping Hex
	[300087] = true, -- Repair
	[300171] = true, -- Repair Protocol
	[300514] = true, -- Stoneskin
	[300414] = true,
	[284219] = true,
	[301629] = true,
	-- MH WS
	[293827] = true, -- Giga-Wallop
	[293930] = true, -- Overclock
	[293729] = true, -- Tune Up
	-- ML
	[269090] = true, -- Artillery Barrage
	[263103] = true, -- Blow Torch
	[268709] = true, -- Earth Shield
	[262554] = true, -- Repair
	[263215] = true, -- Tectonic Barrier
	[268797] = true, -- Transmute: Enemy to Goo
	-- SoB
	[272571] = true, -- Choking Waters
	[274569] = true, -- Revitalizing Mist
	[256957] = true, -- Watertight Shell
	-- SotS
	[268030] = true, -- Mending Rapids
	[267977] = true, -- Tidal Surge
	[274438] = true, -- Tempest
	[267973] = true, -- Wash Away
	[268309] = true, -- Unending Darkness
	-- ToS
	[265968] = true, -- Healing Surge
	[261624] = true, -- Greater Healing Potion
	[267237] = true, -- Drain
	-- TD
	[258128] = true, -- Debilitating Shout
	[257791] = true, -- Howling Fear
	[258935] = true, -- Inner Flames
	[258317] = true, -- Riot Shield
	[258153] = true, -- Watery Dome
	-- UNDR
	[278961] = true, -- Decaying Mind
	[265091] = true, -- Gift of G'huun
	[278755] = true, -- Harrowing Despair
	[272183] = true, -- Raise Dead
	[258347] = true, -- Sonic Screech
	[265433] = true, -- Withering Curse
	-- WM
	[265407] = true, -- Dinner Bell
	[278474] = true, -- Effigy Reconstruction
	[278551] = true, -- Soul Fetish
	[263959] = true, -- Soul Volley
	-- Awakened
	[314592] = true, -- Mind Flay
	[314406] = true, -- Crippling Pestilence
	[314411] = true, -- Lingering Doubt

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- Affix
    [240446] = true, -- Explosive. It's not interruptable, but npcs should be killed before cast is passed
    [366566] = true, -- Burst (Season 3)
    -- Plaguefall
    [319070] = true, -- Corrosive Gunk (Rotmarrow Slime)
    [321999] = true, -- Viral Globs (Pestilence Slime)
    [329163] = true, -- Ambush (Stealthling) It's not interruptable, but npcs can be killed or stunned before cast is passed
    -- Spires of Ascension
    [317936] = true, -- Forsworn Doctrine (Forsworn Mender)
    [317963] = true, -- Burden of Knowledge (Forsworn Castigator)
    [327413] = true, -- Rebellious Fist (Forsworn Goliath)
    [328295] = true, -- Greater Mending (Forsworn Warden)
    [328137] = true, -- Dark Pulse (Forsworn Devastator)
    [328331] = true, -- Forced Confession (Forsworn Justicar)
    -- Theater of Pain
    [341902] = true, -- Unholy Fervor (Battlefield Ritualist)
    [341969] = true, -- Withering Discharge (Blighted Sludge-Spewer)
    [342139] = true, -- Battle Trance
    [330562] = true, -- Demoralizing Shout (Ancient Captain)
    -- The Necrotic Wake
    [320462] = true, -- Necrotic Bolt
    [324293] = true, -- Rasping Scream (Skeletal Marauder)
    [334748] = true, -- Drain Fluids
    [338353] = true, -- Goresplatter (Corpse Collector)
    [320170] = true, -- Necrotic Bolt
    [327130] = true, -- Repair Flesh (Flesh Crafter)
    [335143] = true, -- Bonemend (Zolramus Bonemender)
    [328667] = true, -- Frostbolt Volley
    -- Sanguine Depths
    [319654] = true, -- Hungering Drain (Kryxis the Voracious)
    [322433] = true, -- Stoneskin (Chamber Sentinel)
    [321038] = true, -- Wrack Soul (Wicked Oppressor)
    -- Mists of Tirna Scithe
    [322938] = true, -- Harvest Essence (Drust Harvester)
    [324914] = true, -- Nourish the Forest (Mistveil Tender)
    [324776] = true, -- Bramblethorn Coat (Mistveil Shaper)
    [326046] = true, -- Stimulate Resistance (Spinemaw Staghorn)
    [340544] = true, -- Stimulate Regeneration (Spinemaw Staghorn)
    [337255] = true, -- Parasitic Domination (Tred'ova)
    [337249] = true, -- Parasitic Incapacitation (Tred'ova)
    [337235] = true, -- Parasitic Pacification (Tred'ova)
    [321828] = true, -- Patty Cake (MistCaller)
    -- Halls of Atonement
    [325700] = true, -- Collect Sins (Depraved Collector)
    [323552] = true, -- Volley of Power (High Adjudicator Aleez)
    [323538] = true, -- Bolt of Power (High Adjudicator Aleez)
    [326607] = true, -- Turn to Stone (Stoneborn Reaver)
    -- De Other Side
    [332706] = true, -- Heal (Atal'ai High Priest)
    [332612] = true, -- Healing Wave (Atal'ai Hoodoo Hexxer)
    [332084] = true, -- Self-Cleaning Cycle (Lubricator)
    [332605] = true, -- Hex (Atal'ai Hoodoo Hexxer)
    -- Tazavesh: So'leah's Gambit
    [346980] = true, -- Empowered Defense (Vault Purifier)
    [357260] = true, -- Unstable Rift (Focused Ritualist)
    [357284] = true, -- Reinvigorate (Devoted Accomplice)
    [355057] = true, -- Cry of Mrrggllrrgg (Murkbrine Shellcrusher)
    -- Tazavesh: Streets of Wonder
    [350922] = true, -- Menacing Shout
    [355641] = true, -- Scintillate (Veteran Sparkcaster)
    [355934] = true, -- Hard Light Barrier
    [356031] = true, -- Stasis Beam (Interrogation Specialist)
    [357188] = true, -- Double Technique (So'azmi)
};

local UnitsAppearsInCombat = {
    -------------
    ---- BfA ----
    -------------

    -- AD
    [129517] = true, -- Reanimated Raptor
    -- SotS
    [136314] = true, -- Blowback
    -- UNDR
    [132051] = true, -- Blood Tick

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------
};

local SpecificBuffOrDebuffOnPartyMembers = {
    -------------
    ---- BfA ----
    -------------

    [160029] = true, -- Resurrecting
    -- AD
    [255558] = true, -- Tainted Blood
    [257483] = true, -- Pile of Bones (Rezan void zones with bones)
    -- ML
    [257582] = true, -- Raging Gaze
    -- SoB
    [261428] = true, -- Hangman's Noose
    -- SotS
    [268214] = true, -- Carve Flesh
    [268212] = true, -- Minor Reinforcing Ward
    [267818] = true, -- Slicing Blast
    -- ToS
    [266923] = true, -- Galvanize
    [265315] = true, -- Orb
    [274153] = true, -- Energy Fragment
    [269686] = true, -- Plague
    [268008] = true, -- Snake Charm
    -- UNDR
    [259714] = true, -- Decaying Spores

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- Spires of Ascension
    [330683] = true, -- Raw Anima (Devos)
};

local SpecificBuffOrDebuffOnUnit = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks

    -- Grimrail Depot

    ----------------
    ---- LEGION ----
    ----------------

    -- Karazhan Lower

    -- Karazhan Upper

    -------------
    ---- BfA ----
    -------------

    -- ML
    [271867] = true, -- Pay to Win
    -- SoB
    [257649] = true, -- Boiling Rage
    -- ToS
    [274149] = true, -- Life Force
    -- WM
    [257260] = true, -- Enrage
    [260512] = true, -- Soul Harvest
    [264027] = true, -- Warding Candles
    [264396] = true, -- Spectral Talisman
    [265005] = true, -- Consumed Servant
    [265368] = true, -- Spirited Defense
    [278567] = true, -- Soul Fetish

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- De Other Side
    [322773] = true, -- Blood Barrier (Blood Barrier)
    -- Plaguefall
    [332397] = true, -- Shroudweb (Domina Venomblade adds)
    -- Mists of Tirna Scithe
    [336499] = true, -- Guessing Game (Mistcaller)
    [323149] = true, -- Embrace Darkness (Ingra Maloch)
    [322527] = true, -- Gorging Shield (Tred'ova)
    -- Necrotic Wake
    [321754] = true, -- Icebound Aegis (Nalthor the Rimebinder)
    [326629] = true, -- Noxious Fog (Surgeon Stitchflesh)
    -- Sanguine Depths
    [319657] = true, -- Essence Surge (Kryxis the Voracious)
};

local SpecificCastsDoneByPartyMembers = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks

    -- Grimrail Depot

    -------------
    ---- BfA ----
    -------------

    -- ML
	[255996] = true, -- Punt
	-- TD
	[256578] = true, -- Put Down Gently
	-- ToS
	[265320] = true, -- Throw

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- The Necrotic Wake
    [328404] = true, -- Discharged Anima (use)
    [328351] = true, -- Bloody Javelin (use)
    [328128] = true, -- Forgotten Forgehammer (use)
    [328050] = true, -- Discarded Shield (use)
    -- De Other Side
    [320140] = true, -- Disarming...
    -- Mists of Tirna Scithe
    [340162] = true, -- Savory Statshroom
    [340158] = true, -- Tasty Toughshroom
    -- Halls of Atonement
    [342171] = true, -- Loyal Stoneborn
    -- Sanguine Depths
    [324089] = true, -- Z'rali's Essence
    [324086] = true, -- Shining Radiance
    -- Tazavesh: Streets of Wonder
    [369138] = true, -- Throw Package
    [353221] = true, -- Drum Beat
    [349789] = true, -- Trumpet Slide
    [350731] = true, -- Horn Improvisation
    [349771] = true, -- Sax Solo
    [349026] = true, -- Guitar Riff
};

local SpecificItemsUsedByPartyMembers = {

    -------------
    ---- BfA ----
    -------------

    [318378] = 169223, -- Ashjra'kamas, Shroud of Resolve
	-- Warlock Health Stone
	[6262] = 5512,     -- Healthstone
	-- Alchemy
	[301308] = 169451, -- Abyssal Healing Potion
	[293795] = 156634, -- Silas' Vial of Continuous Curing
	[279154] = 163225, -- Battle Potion of Stamina
	[279151] = 163222, -- Battle Potion of Intellect
	[279152] = 163223, -- Battle Potion of Agility
	[279153] = 163224, -- Battle Potion of Strength
	[298153] = 168499, -- Superior Battle Potion of Stamina
	[298152] = 168498, -- Superior Battle Potion of Intellect
	[298146] = 168489, -- Superior Battle Potion of Agility
	[298154] = 168500, -- Superior Battle Potion of Strength
	[298317] = 168506, -- Potion of Focused Resolve
	[251316] = 152560, -- Potion of Bursting Blood
	[252753] = 152561, -- Potion of Replenishment
	[300741] = 169300, -- Potion of Wild Mending
	[269853] = 152559, -- Potion of Rising Death
	[298157] = 168502, -- Potion of Reconstitution
	[300714] = 169299, -- Potion of Unbridled Fury
	[298225] = 168529, -- Potion of Empowered Proximity
	[251231] = 152557, -- Steelskin Potion
	[298155] = 168501, -- Superior Steelskin Potion
	[250871] = 152495, -- Coastal Mana Potion
	-- Inscription
	[264760] = 158201, -- War-Scroll of Intellect
	[264761] = 158202, -- War-Scroll of Battle Shout
	[264764] = 158204, -- War-Scroll of Fortitude
	-- Trinkets (Raids)
	[313148] = 173944, -- Forbidden Obsidian Claw
	[268999] = 159630, -- Balefire Branch
	[313060] = 173940, -- Sigil of Warding
	[313113] = 173946, -- Writhing Segment of Drest'agath
	[314042] = 174103, -- Manifesto of Madness
	[314585] = 174277, -- Lingering Psychic Shell
	-- Trinkets (Dungeons)
	[271117] = 159615, -- Ignition Mage's Fuse
	[271054] = 158368, -- Fangs of Intertwined Essence
	[266018] = 158320, -- Revitalizing Voodoo Totem
	[271107] = 159617, -- Lustrous Golden Plumage
	[265954] = 158319, -- My'das Talisman
	[265946] = 159618, -- Mchimba's Ritual Bandages
	[271374] = 159611, -- Razdunk's Big Red Button
	[299869] = 168965, -- Modular Platinum Plating
	[302307] = 169769, -- Remote Guidance Device
	[271462] = 159624, -- Rotcrusted Voodoo Doll
	[268828] = 159625, -- Vial of Animated Blood
	[268314] = 159614, -- Galecaller's Boon
	[266047] = 159627, -- Jes' Howler
	[267402] = 158367, -- Merektha's Fang
	-- Trinkets (PvP)
	[277185] = 172669, -- Corrupted Gladiator's Badge

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    -- Warlock Health Stone
    [6262] = 5512, -- Healthstone
    -- Kyrian
    [323436] = 177278, -- Phial of Serenity
    -- Alchemy
    [307192] = 171267, -- Spiritual Healing Potion
    [307193] = 171268, -- Spiritual Mana Potion
    [307495] = 171349, -- Potion of Phantom Fire
    [338385] = 182163, -- Strength of Blood
    [307162] = 171273, -- Potion of Spectral Intellect
    [307159] = 171270, -- Potion of Spectral Agility
    [334436] = 180771, -- Potion of Unusual Strength
    [307164] = 171275, -- Potion of Spectral Strength
    [307497] = 171351, -- Potion of Deathly Fixation
    [307161] = 171272, -- Potion of Spiritual Clarity
    [307494] = 171352, -- Potion of Empowered Exorcisms
    [331974] = 180317, -- Soulful Healing Potion
    [307496] = 171350, -- Potion of Divine Awakening
    [322302] = 176811, -- Potion of Sacrificial Anima
    [307195] = 171266, -- Potion of the Hidden Spirit
    [307163] = 171274, -- Potion of Spectral Stamina
    [307501] = 171370, -- Potion of Specter Swiftness
    [307199] = 171263, -- Potion of Soul Purity
    [331978] = 180318, -- Soulful Mana Potion
    [307160] = 171271, -- Potion of Hardened Shadows
    [307194] = 171269, -- Spiritual Rejuvenation Potion
    [307196] = 171264, -- Potion of Shaded Sight
    [359867] = 187802, -- Cosmic Healing Potion
    -- Trinkets (Raids)
    -- CN
    [344662] = 184025, -- Memory of Past Sins
    [344245] = 184029, -- Manabound Mirror
    [344231] = 184031, -- Sanguine Vintage
    [345019] = 184016, -- Skulker's Wing
    [345432] = 184024, -- Macabre Sheet Music
    [344384] = 184017, -- Bargast's Leash
    [345251] = 184019, -- Soul Igniter
    [344916] = 184020, -- Tuft of Smoldering Plumage
    [345500] = 184021, -- Glyph of Assimilation
    [344732] = 184030, -- Dreadfire Vessel
    -- SOD
    [353692] = 186422, -- Tome of Monstrous Constructions
    [355333] = 186432, -- Salvaged Fusion Amplifier
    [355327] = 186431, -- Ebonsoul Vise
    [355327] = 186421, -- Forbidden Necromantic Tome
    [355321] = 186428, -- Shadowed Orb of Torment
    [358712] = 186424, -- Shard of Annhylde's Aegis
    [355303] = 186437, -- Relic of the Frozen Wastes

    -- Trinkets (Dungeons)
    [342423] = 178862, -- Bladedancer's Armor Kit
    [343385] = 178849, -- Overflowing Anima Cage
    [342432] = 178850, -- Lingering Sunmote
    [345549] = 178783, -- Siphoning Phylactery Shard
    [345548] = 178751, -- Spare Meat Hook
    [345547] = 178742, -- Bottled Flayedwing Toxin
    [329840] = 179331, -- Blood-Spattered Scale
    [330323] = 179350, -- Inscrutable Quantum Device TODO or 348098
    [329831] = 179342, -- Overwhelming Power Crystal
    [331523] = 179356, -- Shadowgrasp Totem
    [345739] = 178811, -- Grim Codex
    [345801] = 178809, -- Soulletting Ruby
    [-2] = 178810, -- Vial of Spectral Essence
    [330067] = 178715, -- Mistcaller Ocarina
    [343393] = 178826, -- Sunblood Amethyst
    [343399] = 178825, -- Pulsating Stoneheart
    [345595] = 178770, -- Slimy Consumptive Organ
    [345539] = 180117, -- Empyreal Ordnance
    [345530] = 180116, -- Overcharged Anima Battery
    [351926] = 185818, -- So'leah's Secret Technique
    -- Trinkets (Professions)
    [333734] = 173078, -- Darkmoon Deck: Repose
    [311444] = 173096, -- Darkmoon Deck: Indomitable Deck
    [331624] = 173087, -- Darkmoon Deck: Voracity
    [347047] = 173069, -- Darkmoon Deck: Putrescence
    -- Trinkets (PvP)
    [345228] = 175884, -- Sinful Aspirant's Badge of Ferocity (same spell is for item 175921)
    [345231] = 178334, -- Sinful Aspirant's Emblem (same spell is for item 178447)
    [345229] = 178298, -- Sinful Gladiator's Insignia of Alacrity (same spell is for item 178386)
};

local DamageDoneToSpecificUnits = {

    -----------------------------
    ---- Warlords of Draenor ----
    -----------------------------

    -- Iron Docks
    [79852] = {
        type = "BOSS"
    },
    [83612] = {
        type = "BOSS"
    },
    [80816] = {
        type = "BOSS"
    },
    [83616] = {
        type = "BOSS"
    },
    [80805] = {
        type = "BOSS"
    },
    [80808] = {
        type = "BOSS"
    },
    [81297] = {
        type = "BOSS"
    },
    [81305] = {
        type = "BOSS"
    },
    [83613] = {
        type = "BOSS"
    },
    [89011] = {
        type = "ADD"
    },
    [89012] = {
        type = "ADD"
    },

    -- Grimrail Depot

    [79545] = {
        type = "BOSS"
    },
    [77816] = {
        type = "BOSS"
    },
    [77803] = {
        type = "BOSS"
    },
    [80005] = {
        type = "BOSS"
    },

    ----------------
    ---- LEGION ----
    ----------------

    -- Karazhan Lower
    [113971] = {
        type = "BOSS",
    },
    [114251] = {
        type = "BOSS",
    },
    [114284] = {
        type = "BOSS",
    },
    [114312] = {
        type = "BOSS",
    },
    [114262] = {
        type = "BOSS",
    },
    [114264] = {
        type = "BOSS",
    },
    [114319] = {
        type = "ADD",
    },
    [114320] = {
        type = "ADD",
    },
    [114317] = {
        type = "ADD",
    },
    [114316] = {
        type = "ADD",
    },
    [114321] = {
        type = "ADD",
    },
    [114318] = {
        type = "ADD",
    },
    [114328] = {
        type = "BOSS",
    },
    [114522] = {
        type = "ADD",
    },
    [114329] = {
        type = "ADD",
    },
    [114330] = {
        type = "ADD",
    },
    [114324] = {
        type = "ADD",
    },

    -- Karazhan Upper
    [114790] = {
        type = "BOSS",
    },
    [114247] = {
        type = "BOSS",
    },
    [114252] = {
        type = "BOSS",
    },
    [114350] = {
        type = "BOSS",
    },
    [114249] = {
        type = "ADD",
    },
    [114675] = {
        type = "ADD",
    },
    [115730] = {
        type = "ADD",
    },

    -------------
    ---- BfA ----
    -------------

    [120651] = {
        name = L["Explosives"]
    },
    [161510] = {
        name = L["Mindrend Tentacle"]
    },
    -- AD
    [129517] = {
        name = L["Reanimated Raptor"]
    },
    -- KR
    [136976] = {
        name = L["T'zala"]
    },
    [136984] = {
        name = L["Reban"]
    },
    [135406] = {
        name = L["Animated Gold"]
    },
    -- ML
    [129802] = {
        name = L["Earthrager"]
    },
    [133436] = {
        name = L["Venture Co. Skyscorcher"]
    },
    -- MW
    [152033] = {
        name = L["Inconspicuous Plant"]
    },
    -- SoB
    [136549] = {
        name = L["Ashvane Cannoneer"]
    },
    [270590] = {
        name = L["Hull Cracker"]
    },
    [137405] = {
        name = L["Gripping Terror"]
    },
    -- TD
    [131785] = {
        name = L["Buzzing Drone"]
    },
    --ToS
    [134388] = {
        name = L["A Knot of Snakes"]
    },
    -- UNDR
    [134701] = {
        name = L["Blood Effigy"]
    },
    [132051] = {
        name = L["Blood Tick"]
    },
    [137103] = {
        name = L["Blood Visage"]
    },
    -- WM
    [136330] = {
        name = L["Soul Thorns"]
    },
    [133361] = {
        name = L["Wasting Servant"]
    },
    [135552] = {
        name = L["Deathtouched Slaver"]
    },
    -- MECHAGON JUNKYARD
    [150159] = {
        type = "BOSS",
    },
    [150712] = {
        type = "BOSS",
    },
    [150222] = {
        type = "BOSS",
    },
    [150190] = {
        type = "BOSS",
    },
    [153755] = {
        type = "BOSS",
    },
    [150295] = {
        type = "BOSS",
    },
    [153756] = {
        type = "BOSS",
    },
    -- MECHAGON MASTERY
    [144248] = {
        type = "BOSS",
    },
    [144246] = {
        type = "BOSS",
    },
    [144249] = {
        type = "BOSS",
    },
    [145185] = {
        type = "BOSS",
    },
    [144244] = {
        type = "BOSS",
    },
    [150397] = {
        type = "BOSS",
    },
    [150396] = {
        type = "BOSS",
    },
    [152033] = {
        type = "ADD",
    },

    ---------------------
    ---- SHADOWLANDS ----
    ---------------------

    [120651] = {
        type = "AFFIX"
    }, -- Explosive Orbs
    [174773] = {
        type = "AFFIX"
    }, -- Spiteful Shade
    [173729] = {
        type = "AFFIX"
    }, -- Manifestation of Pride
    [185685] = {
        type = "AFFIX"
    }, -- Urh Relic
    [185683] = {
        type = "AFFIX"
    }, -- Wo Relic
    [185680] = {
        type = "AFFIX"
    }, -- Vy Relic
    [184911] = {
        type = "AFFIX"
    }, -- Urh Dismantler
    [184908] = {
        type = "AFFIX"
    }, -- Vy Interceptor
    [184910] = {
        type = "AFFIX"
    }, -- Wo Drifter
    [190128] = {
        type = "AFFIX"
    },
    [189878] = {
        type = "AFFIX"
    },

    -- Plaguefall
    [164362] = {
        type = "ADD"
    }, -- Slimy Morsel (Globgrog adds)
    [171887] = {
        type = "ADD"
    }, -- Slimy Smorgasbord (Globgrog adds)
    [163915] = {
        type = "MOB"
    }, -- Hatchling Nest
    [169159] = {
        type = "MOB"
    }, -- Unstable Canister
    [169498] = {
        type = "ADD"
    }, -- Plague Bomb (Doctor Ickus adds)
    [168837] = {
        type = "MOB"
    }, -- Stealthling
    [170474] = {
        type = "ADD"
    }, -- Brood Assassin (Domina Venomblade adds)
    [165430] = {
        type = "ADD"
    }, -- Malignant Spawn (Margrave Stradama adds)
    [164255] = {
        type = "BOSS"
    }, -- Globgrog
    [164967] = {
        type = "BOSS"
    }, -- Doctor Ickus
    [164266] = {
        type = "BOSS"
    }, -- Domina Venomblade,
    [164267] = {
        type = "BOSS"
    }, -- Margrave Stradama

    -- The Necrotic Wake
    [163121] = {
        type = "MOB"
    }, -- Stitched Vanguard
    [164702] = {
        type = "ADD"
    }, -- Carrion Worm (Blightbone adds)
    [164414] = {
        type = "ADD"
    }, -- Reanimated Mage (Amarth adds)
    [164427] = {
        type = "ADD"
    }, -- Reanimated Warrior (Amarth adds)
    [168246] = {
        type = "ADD"
    }, -- Reanimated Crossbowman (Amarth adds)
    [162691] = {
        type = "BOSS"
    }, -- Blightbone
    [163157] = {
        type = "BOSS"
    }, -- Amarth
    [162689] = {
        type = "BOSS"
    }, -- Surgeon Stitchflesh
    [162693] = {
        type = "BOSS"
    }, -- Nalthor the Rimebinder

    -- Spires of Ascension
    [163077] = {
        type = "BOSS"
    }, -- Azules
    [162059] = {
        type = "BOSS"
    }, -- Kin-Tara
    [162058] = {
        type = "BOSS"
    }, -- Ventunax
    [162060] = {
        type = "BOSS"
    }, -- Oryphrion
    [162061] = {
        type = "BOSS"
    }, -- Devos

    -- Sanguine Depths
    [168882] = {
        type = "MOB"
    }, -- Fleeting Manifestation
    [162100] = {
        type = "BOSS"
    }, -- Kryxis the Voracious
    [162103] = {
        type = "BOSS"
    }, -- Executor Tarvold
    [162102] = {
        type = "BOSS"
    }, -- Grand Proctor Beryllia
    [162133] = {
        type = "ADD"
    }, -- General Kaal
    [162099] = {
        type = "BOSS"
    }, -- General Kaal
    [165556] = {
        type = "ADD"
    }, -- Fleeting Manifestation

    -- Mists of Tirna Scithe
    [165251] = {
        type = "ADD"
    }, -- Illusionary Vulpin
    [165560] = {
        type = "ADD"
    }, -- Gormling Larva
    [164567] = {
        type = "BOSS"
    }, -- Ingra Maloch
    [164501] = {
        type = "BOSS"
    }, -- Mistcaller
    [164517] = {
        type = "BOSS"
    }, -- Tred'ova
    [164804] = {
        type = "BOSS"
    }, -- Droman Oulfarran

    -- De Other Side
    [165905] = {
        type = "ADD"
    }, -- Son of Hakkar (Hakkar adds),
    [164450] = {
        type = "BOSS",
    }, -- Dealer Xy'exa
    [164558] = {
        type = "BOSS"
    }, -- Hakkar the Soulflayer
    [164555] = {
        type = "BOSS"
    }, -- Millificent Manastorm
    [164556] = {
        type = "BOSS"
    }, -- Millhouse Manastorm
    [166608] = {
        type = "BOSS"
    }, -- Mueh'zala
    [168326] = {
        type = "ADD"
    }, -- Shattered Visage

    -- Halls of Atonement
    [165408] = {
        type = "BOSS"
    }, -- Halkias
    [164185] = {
        type = "BOSS"
    }, -- Echelon
    [165410] = {
        type = "BOSS"
    }, -- High Adjudicator Aleez
    [164218] = {
        type = "BOSS"
    }, -- Lord Chamberlain

    -- Theater of Pain
    [164451] = {
        type = "BOSS"
    }, -- Dessia the Decapitator
    [164463] = {
        type = "BOSS"
    }, -- Paceran the Virulent
    [164461] = {
        type = "BOSS"
    }, -- Sathel the Accursed
    [162317] = {
        type = "BOSS"
    }, -- Gorechop
    [162329] = {
        type = "BOSS"
    }, -- Xav the Unfallen
    [162309] = {
        type = "BOSS"
    }, -- Kul'tharok
    [165946] = {
        type = "BOSS"
    }, -- Mordretha, the Endless Empress
    [170234] = {
        type = "ADD"
    }, -- Oppressive Banner

    -- Tazavesh: So'leah's Gambit
    [175663] = {
        type = "BOSS"
    }, -- Hylbrande <Sword of the Keepers>
    [177269] = {
        type = "BOSS"
    }, -- So'leah <Cartel So>
    [175546] = {
        type = "BOSS"
    }, -- Timecap'n Hooktail
    [176551] = {
        type = "ADD",
    },
    [177500] = {
        type = "ADD",
    },
    [177716] = {
        type = "ADD",
    },

    -- Tazavesh: Streets of Wonder
    [175646] = {
        type = "BOSS"
    }, -- P.O.S.T. Master
    [175806] = {
        type = "BOSS"
    }, -- So'azmi
    [175616] = {
        type = "BOSS"
    }, -- Zo'phex <The Sentinel>
    [176563] = {
        type = "BOSS"
    }, -- Zo'gron
    [176555] = {
        type = "BOSS"
    }, -- Achillite <The Pummeler>
    [176556] = {
        type = "BOSS"
    }, -- Alcruux <The Glutton>
    [176705] = {
        type = "BOSS"
    }, -- Venza Goldfuse
    [177237] = {
        type = "ADD"
    }, -- Chains of Damnation
};

function MyDungeonsBook:GetDamageDoneToSpecificUnits()
	return DamageDoneToSpecificUnits;
end

function MyDungeonsBook:GetSpellsToInterrupt()
    return SpellsToInterrupt;
end

function MyDungeonsBook:GetAvoidableSpells()
    return Spells;
end

function MyDungeonsBook:GetAvoidableSpellsNoTank()
    return SpellsNoTank;
end

function MyDungeonsBook:GetAvoidableAuras()
    return Auras;
end

function MyDungeonsBook:GetAvoidableAurasNoTank()
    return AurasNoTank;
end

function MyDungeonsBook:TrackAvoidableSpellsWrapper(damagedUnit, spellId, amount)
	self:TrackAvoidableSpells("SL-AVOIDABLE-SPELLS", Spells, SpellsNoTank, damagedUnit, spellId, amount);
end

function MyDungeonsBook:TrackPassedCastsWrapper(caster, spellId, raidFlags)
	self:TrackPassedCasts("SL-SPELLS-TO-INTERRUPT", SpellsToInterrupt, caster, spellId, raidFlags);
end

function MyDungeonsBook:TrackUnitsAppearsInCombatWrapper(sourceUnitGUID, targetUnitGUID)
	self:TrackUnitsAppearsInCombat("SL-UNITS-APPEARS-IN-COMBAT", UnitsAppearsInCombat, sourceUnitGUID, targetUnitGUID);
end

function MyDungeonsBook:TrackSpecificBuffOrDebuffOnPartyMembersWrapper(unit, spellId)
	self:TrackSpecificBuffOrDebuffOnPartyMembers("SL-BUFFS-OR-DEBUFFS-ON-PARTY-MEMBERS", SpecificBuffOrDebuffOnPartyMembers, unit, spellId);
end

function MyDungeonsBook:TrackSpecificBuffOrDebuffOnUnit(sourceUnitName, sourceUnitGUID, sourceUnitFlags, spellId, auraType, amount)
	self:TrackSpecificAuraAddedToEnemyUnits("SL-BUFFS-OR-DEBUFFS-ON-UNIT", SpecificBuffOrDebuffOnUnit, sourceUnitName, sourceUnitGUID, sourceUnitFlags, spellId, auraType, amount);
end

function MyDungeonsBook:TrackSpecificBuffOrDebuffRemovedFromUnit(sourceUnitName, sourceUnitGUID, sourceUnitFlags, spellId, auraType, amount)
	self:TrackAuraRemovedFromEnemyUnits("SL-BUFFS-OR-DEBUFFS-ON-UNIT", SpecificBuffOrDebuffOnUnit, sourceUnitName, sourceUnitGUID, sourceUnitFlags, spellId, auraType, amount);
end

function MyDungeonsBook:TrackSpecificCastDoneByPartyMembersWrapper(unit, spellId)
	self:TrackSpecificCastDoneByPartyMembers("SL-CASTS-DONE-BY-PARTY-MEMBERS", SpecificCastsDoneByPartyMembers, unit, spellId);
end

function MyDungeonsBook:TrackSpecificItemUsedByPartyMembersWrapper(unit, spellId)
	self:TrackSpecificItemUsedByPartyMembers("SL-ITEM-USED-BY-PARTY-MEMBERS", SpecificItemsUsedByPartyMembers, unit, spellId);
end

function MyDungeonsBook:TrackDamageDoneToSpecificUnitsWrapper(sourceName, sourceGUID, spellId, amount, overkill, targetName, targetGUID)
	self:TrackDamageDoneToSpecificUnits("SL-DAMAGE-DONE-TO-UNITS", DamageDoneToSpecificUnits, sourceName, sourceGUID, spellId, amount, overkill, targetName, targetGUID);
end
