--[[--
@module MyDungeonsBook
]]

--[[--
Utils
@section Utils
]]

function MyDungeonsBook:WA_CustomActionOnSpellSuccess_Template_Get()
    return {
        ["iconSource"] = -1,
        ["authorOptions"] = {
        },
        ["preferToUpdate"] = false,
        ["yOffset"] = 0,
        ["anchorPoint"] = "CENTER",
        ["cooldownSwipe"] = true,
        ["cooldownEdge"] = false,
        ["icon"] = true,
        ["triggers"] = {
            [1] = {
                ["trigger"] = {
                    ["use_sourceFlags2"] = true,
                    ["type"] = "combatlog",
                    ["spellId"] = "162407",
                    ["subeventSuffix"] = "_CAST_SUCCESS",
                    ["names"] = {
                    },
                    ["duration"] = "5",
                    ["event"] = "Combat Log",
                    ["unit"] = "player",
                    ["subeventPrefix"] = "SPELL",
                    ["use_spellId"] = true,
                    ["spellIds"] = {
                    },
                    ["use_sourceUnit"] = false,
                    ["sourceFlags2"] = "Hostile",
                    ["use_sourceFlags3"] = false,
                    ["use_cloneId"] = true,
                    ["debuffType"] = "HELPFUL",
                },
                ["untrigger"] = {
                },
            },
            ["activeTriggerMode"] = -10,
        },
        ["internalVersion"] = 53,
        ["keepAspectRatio"] = false,
        ["selfPoint"] = "CENTER",
        ["desaturate"] = false,
        ["subRegions"] = {
            [1] = {
                ["type"] = "subbackground",
            },
            [2] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "HEAL",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "OUTER_BOTTOM",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [3] = {
                ["glowFrequency"] = 0.25,
                ["type"] = "subglow",
                ["glowXOffset"] = 0,
                ["glowType"] = "Pixel",
                ["glowLength"] = 10,
                ["glowYOffset"] = 0,
                ["glowColor"] = {
                    [1] = 0.77647058823529,
                    [2] = 0.6078431372549,
                    [3] = 0.42745098039216,
                    [4] = 1,
                },
                ["useGlowColor"] = true,
                ["glow"] = true,
                ["glowThickness"] = 3,
                ["glowScale"] = 1,
                ["glowLines"] = 8,
                ["glowBorder"] = false,
            },
        },
        ["height"] = 128,
        ["load"] = {
            ["talent"] = {
                ["multi"] = {
                },
            },
            ["size"] = {
                ["multi"] = {
                },
            },
            ["class"] = {
                ["multi"] = {
                },
            },
            ["spec"] = {
                ["multi"] = {
                },
            },
        },
        ["source"] = "import",
        ["displayIcon"] = 134279,
        ["parent"] = "",
        ["regionType"] = "icon",
        ["information"] = {
        },
        ["animation"] = {
            ["start"] = {
                ["easeStrength"] = 3,
                ["type"] = "none",
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["main"] = {
                ["easeStrength"] = 3,
                ["type"] = "none",
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["finish"] = {
                ["easeStrength"] = 3,
                ["type"] = "none",
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
        },
        ["useCooldownModRate"] = true,
        ["zoom"] = 0.3,
        ["actions"] = {
            ["start"] = {
            },
            ["finish"] = {
            },
            ["init"] = {
            },
        },
        ["cooldownTextDisabled"] = false,
        ["uid"] = "",
        ["id"] = "",
        ["color"] = {
            [1] = 1,
            [2] = 1,
            [3] = 1,
            [4] = 1,
        },
        ["alpha"] = 1,
        ["anchorFrameType"] = "SCREEN",
        ["frameStrata"] = 1,
        ["config"] = {
        },
        ["inverse"] = false,
        ["width"] = 128,
        ["conditions"] = {
        },
        ["cooldown"] = true,
        ["xOffset"] = 0,
    };
end

--[[--
@param[type=table] auraData
@param[type=number|nil] instanceId
@param[type=number|nil] bossId
@param[type=number|nil] affixId
@return[type=boolean]
]]
function MyDungeonsBook:WA_CustomActionOnSpellSuccess_Aura_Create(auraData, instanceId, bossId, affixId, customText)
    local wa = self:WA_CustomActionOnSpellSuccess_Template_Get();
    local spellId = auraData.spellId;
    local _, _, icon, castTime = GetSpellInfo(spellId);
    wa.triggers[1].trigger.spellId = string.format("%s", spellId);
    wa.subRegions[2].text_text = customText;
    wa.displayIcon = icon;
    wa.id = self:Wa_GenerateId(auraData, instanceId, bossId, affixId, "Custom Action - " .. customText);

    return self:Wa_AddNewWeakAura(wa, auraData, instanceId, bossId, affixId);
end

function MyDungeonsBook:Wa_ContextMenuItem_CustomActionOnSpellSuccess_Create(spellId, instanceId, bosses, affixes)
    local menuItemsForBosses = {};
    for bossId, bossInfo in pairs(bosses) do
        tinsert(menuItemsForBosses, {
            text = bossInfo.name,
            func = function()
                StaticPopup_Show("MDB_WA_CUSTOM_TEXT_INPUT", "", "", {
                    auraData = {spellId = spellId},
                    bossId = bossId,
                    instanceId = instanceId,
                    type = "CUSTOM_ACTION_ON_SPELL_CAST_SUCCESS"
                });
            end
        });
    end
    local menuItemsForAffixes = {};
    for _, affixId in pairs(affixes) do
        tinsert(menuItemsForAffixes, {
            text = self:GetAffixMetaInfo(affixId).name,
            func = function()
                StaticPopup_Show("MDB_WA_CUSTOM_TEXT_INPUT", "", "", {
                    auraData = {spellId = spellId},
                    affixId = affixId,
                    type = "CUSTOM_ACTION_ON_SPELL_CAST_SUCCESS"
                });
            end
        });
    end
    return {
        text = "Custom Action on Spell Cast SUCCESS",
        hasArrow = true,
        menuList = {
            {
                text = "Trash",
                func = function()
                    StaticPopup_Show("MDB_WA_CUSTOM_TEXT_INPUT", "", "", {
                        auraData = { spellId = spellId },
                        instanceId = instanceId,
                        type = "CUSTOM_ACTION_ON_SPELL_CAST_SUCCESS"
                    });
                end
            },
            {
                text = "Boss",
                hasArrow = true,
                menuList = menuItemsForBosses
            },
            {
                text = "Affix",
                hasArrow = true,
                menuList = menuItemsForAffixes
            }
        }
    };
end
