--[[--
@module MyDungeonsBook
]]

--[[--
Utils
@section Utils
]]

function MyDungeonsBook:WA_DispelEnemy_Template_Get()
    return {
        ["iconSource"] = -1,
        ["xOffset"] = 0,
        ["yOffset"] = 0,
        ["anchorPoint"] = "CENTER",
        ["cooldownSwipe"] = true,
        ["cooldownEdge"] = false,
        ["icon"] = true,
        ["triggers"] = {
            [1] = {
                ["trigger"] = {
                    ["useGroup_count"] = true,
                    ["useHostility"] = true,
                    ["unit"] = "nameplate",
                    ["group_count"] = "0",
                    ["group_countOperator"] = ">",
                    ["ignoreDead"] = false,
                    ["useExactSpellId"] = true,
                    ["event"] = "Health",
                    ["subeventPrefix"] = "SPELL",
                    ["ignoreDisconnected"] = false,
                    ["type"] = "aura2",
                    ["auraspellids"] = {
                    },
                    ["names"] = {
                    },
                    ["subeventSuffix"] = "_CAST_START",
                    ["debuffType"] = "HELPFUL",
                    ["useAffected"] = true,
                    ["hostility"] = "hostile",
                },
                ["untrigger"] = {
                },
            },
            ["activeTriggerMode"] = -10,
        },
        ["internalVersion"] = 51,
        ["keepAspectRatio"] = false,
        ["selfPoint"] = "CENTER",
        ["desaturate"] = false,
        ["subRegions"] = {
            [1] = {
                ["type"] = "subbackground",
            },
            [2] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "%unitCount",
                ["text_text_format_unitsCount_format"] = "none",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "INNER_BOTTOMRIGHT",
                ["text_fontType"] = "OUTLINE",
                ["text_text_format_unitCount_format"] = "none",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_text_format_affected_format"] = "none",
            },
            [3] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "",
                ["text_text_format_unitsCount_format"] = "none",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "OUTER_BOTTOM",
                ["text_text_format_affected_format"] = "none",
                ["text_fontSize"] = 32,
                ["text_text_format_unitCount_format"] = "none",
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [4] = {
                ["glowFrequency"] = 0.25,
                ["type"] = "subglow",
                ["glowXOffset"] = 0,
                ["glowType"] = "Pixel",
                ["glowLength"] = 10,
                ["glowYOffset"] = 0,
                ["glowColor"] = {
                    [1] = 0,
                    [2] = 1,
                    [3] = 0.59607843137255,
                    [4] = 1,
                },
                ["useGlowColor"] = true,
                ["glow"] = true,
                ["glowScale"] = 1,
                ["glowThickness"] = 3,
                ["glowLines"] = 8,
                ["glowBorder"] = false,
            },
        },
        ["height"] = 128,
        ["load"] = {
            ["class_and_spec"] = {
                ["multi"] = {},
            },
            ["use_class_and_spec"] = false,
            ["size"] = {
                ["multi"] = {
                },
            },
        },
        ["regionType"] = "icon",
        ["authorOptions"] = {
        },
        ["zoom"] = 0.3,
        ["cooldown"] = false,
        ["cooldownTextDisabled"] = false,
        ["color"] = {
            [1] = 1,
            [2] = 1,
            [3] = 1,
            [4] = 1,
        },
        ["alpha"] = 1,
        ["id"] = "",
        ["config"] = {
        },
        ["frameStrata"] = 1,
        ["width"] = 128,
        ["anchorFrameType"] = "SCREEN",
        ["uid"] = "",
        ["inverse"] = false,
        ["actions"] = {
            ["start"] = {
            },
            ["init"] = {
            },
            ["finish"] = {
            },
        },
        ["conditions"] = {
        },
        ["information"] = {
        },
        ["animation"] = {
            ["start"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["main"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["finish"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
        },
    };
end

local function getSpecIdsDispelEnemyMagic()
    return {
        [63] = true,
        [262] = true,
        [263] = true,
        [264] = true,
        [253] = true,
        [254] = true,
        [62] = true,
        [255] = true,
        [64] = true,
        [256] = true,
        [257] = true,
        [258] = true,
        [577] = true,
        [581] = true,
    };
end
local function getSpecIdsDispelEnemyEnrage()
    return {
        [103] = true,
        [261] = true,
        [104] = true,
        [253] = true,
        [260] = true,
        [254] = true,
        [105] = true,
        [255] = true,
        [102] = true,
        [259] = true,
    };
end

function MyDungeonsBook:WA_DispelEnemy_Aura_Create(auraData, instanceId, bossId, affixId, dispelType)
    local wa = self:WA_DispelEnemy_Template_Get();
    local spellId = auraData.spellId;
    local loadForSpecs = {};
    if (dispelType == "MAGIC") then
        loadForSpecs = getSpecIdsDispelEnemyMagic();
    end
    if (dispelType == "ENRAGE") then
        loadForSpecs = getSpecIdsDispelEnemyEnrage();
    end
    local _, _, icon = GetSpellInfo(spellId);
    wa.load.class_and_spec.multi = loadForSpecs;
    tinsert(wa.triggers[1].trigger.auraspellids, string.format("%s", spellId));
    wa.displayIcon = icon;
    wa.subRegions[3].text_text = dispelType;
    wa.id = self:Wa_GenerateId(auraData, instanceId, bossId, affixId, "Enemy Tracker", string.format("[%s]", dispelType));

    return self:Wa_AddNewWeakAura(wa, auraData, instanceId, bossId, affixId);
end


function MyDungeonsBook:Wa_ContextMenuItem_DispelEnemy_Create(spellId, instanceId, bosses, affixes)
    local dispelTypes = { "MAGIC", "ENRAGE" };
    local menuList = {};
    for _, dispelType in pairs(dispelTypes) do
        local menuItemsForBosses = {};
        for bossId, bossInfo in pairs(bosses) do
            tinsert(menuItemsForBosses, {
                text = bossInfo.name,
                func = function()
                    self:WA_DispelEnemy_Aura_Create({ spellId = spellId }, instanceId, bossId, nil, dispelType);
                end
            });
        end
        local menuItemsForAffixes = {};
        for _, affixId in pairs(affixes) do
            tinsert(menuItemsForAffixes, {
                text = self:GetAffixMetaInfo(affixId).name,
                func = function()
                    self:WA_DispelEnemy_Aura_Create({ spellId = spellId }, nil, nil, affixId, dispelType);
                end
            });
        end
        tinsert(menuList, {
            text = dispelType,
            hasArrow = true,
            menuList = {
                {
                    text = "Trash",
                    func = function()
                        self:WA_DispelEnemy_Aura_Create({ spellId = spellId }, instanceId, nil, nil, dispelType);
                    end
                },
                {
                    text = "Boss",
                    hasArrow = true,
                    menuList = menuItemsForBosses
                },
                {
                    text = "Affix",
                    hasArrow = true,
                    menuList = menuItemsForAffixes
                }
            }
        });
    end
    return {
        text = "Dispel enemy as",
        hasArrow = true,
        menuList = menuList
    };
end
