--[[--
@module MyDungeonsBook
]]

--[[--
Utils
@section Utils
]]

function MyDungeonsBook:WA_EnemyShield_Template_Get()
    return {
        ["iconSource"] = -1,
        ["color"] = {
            [1] = 1,
            [2] = 1,
            [3] = 1,
            [4] = 1,
        },
        ["yOffset"] = 0,
        ["anchorPoint"] = "CENTER",
        ["cooldownSwipe"] = true,
        ["cooldownEdge"] = false,
        ["icon"] = true,
        ["triggers"] = {
            [1] = {
                ["trigger"] = {
                    ["useGroup_count"] = true,
                    ["useHostility"] = true,
                    ["unit"] = "nameplate",
                    ["use_tooltipValue"] = false,
                    ["group_count"] = "0",
                    ["debuffType"] = "HELPFUL",
                    ["showClones"] = true,
                    ["type"] = "aura2",
                    ["useExactSpellId"] = true,
                    ["fetchTooltip"] = true,
                    ["event"] = "Health",
                    ["hostility"] = "hostile",
                    ["auraspellids"] = {
                    },
                    ["group_countOperator"] = ">",
                    ["fetchRole"] = false,
                    ["subeventSuffix"] = "_CAST_START",
                    ["subeventPrefix"] = "SPELL",
                    ["names"] = {
                    },
                },
                ["untrigger"] = {
                },
            },
            ["activeTriggerMode"] = -10,
        },
        ["internalVersion"] = 51,
        ["keepAspectRatio"] = false,
        ["selfPoint"] = "CENTER",
        ["desaturate"] = false,
        ["subRegions"] = {
            [1] = {
                ["type"] = "subbackground",
            },
            [2] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "Shield",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "OUTER_BOTTOM",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [3] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "%tooltip1",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_text_format_tooltip1_format"] = "BigNumber",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "CENTER",
                ["text_text_format_tooltip1_big_number_format"] = "AbbreviateNumbers",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [4] = {
                ["border_offset"] = 0,
                ["type"] = "subborder",
                ["border_color"] = {
                    [1] = 0,
                    [2] = 0.43921568627451,
                    [3] = 0.86666666666667,
                    [4] = 1,
                },
                ["border_visible"] = true,
                ["border_edge"] = "1 Pixel",
                ["border_size"] = 3,
            },
        },
        ["height"] = 128,
        ["load"] = {
            ["size"] = {
                ["multi"] = {
                },
            },
        },
        ["regionType"] = "icon",
        ["actions"] = {
            ["start"] = {
            },
            ["init"] = {
            },
            ["finish"] = {
            },
        },
        ["cooldown"] = true,
        ["xOffset"] = 0,
        ["zoom"] = 0.3,
        ["authorOptions"] = {
        },
        ["anchorFrameType"] = "SCREEN",
        ["id"] = "",
        ["config"] = {
        },
        ["alpha"] = 1,
        ["width"] = 128,
        ["frameStrata"] = 1,
        ["uid"] = "",
        ["inverse"] = false,
        ["cooldownTextDisabled"] = true,
        ["conditions"] = {
        },
        ["information"] = {
        },
        ["animation"] = {
            ["start"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["main"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["finish"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
        },
    };
end


function MyDungeonsBook:WA_EnemyShield_Aura_Create(auraData, instanceId, bossId, affixId)
    local wa = self:WA_EnemyShield_Template_Get();
    local spellId = auraData.spellId;
    local _, _, icon, castTime = GetSpellInfo(spellId);
    tinsert(wa.triggers[1].trigger.auraspellids, string.format("%s", spellId));
    wa.triggers[1].trigger.duration = string.format("%s", castTime / 1000);
    wa.displayIcon = icon;
    wa.id = self:Wa_GenerateId(auraData, instanceId, bossId, affixId, "Shield");

    return self:Wa_AddNewWeakAura(wa, auraData, instanceId, bossId, affixId);
end

function MyDungeonsBook:Wa_ContextMenuItem_EnemyShield_Create(spellId, instanceId, bosses, affixes)
    local menuItemsForBosses = {};
    for bossId, bossInfo in pairs(bosses) do
        tinsert(menuItemsForBosses, {
            text = bossInfo.name,
            func = function()
                self:WA_EnemyShield_Aura_Create({spellId = spellId}, instanceId, bossId);
            end
        });
    end
    local menuItemsForAffixes = {};
    for _, affixId in pairs(affixes) do
        tinsert(menuItemsForAffixes, {
            text = self:GetAffixMetaInfo(affixId).name,
            func = function()
                self:WA_EnemyShield_Aura_Create({ spellId = spellId }, nil, nil, affixId);
            end
        });
    end
    return {
        text = "Enemy Shield",
        hasArrow = true,
        menuList = {
            {
                text = "Trash",
                func = function()
                    self:WA_EnemyShield_Aura_Create({ spellId = spellId }, instanceId, nil, nil);
                end
            },
            {
                text = "Boss",
                hasArrow = true,
                menuList = menuItemsForBosses
            },
            {
                text = "Affix",
                hasArrow = true,
                menuList = menuItemsForAffixes
            }
        }
    };
end
