--[[--
@param[type=table] auraData
@param[type=number|nil] instanceId
@param[type=number|nil] bossId
@param[type=number|nil] affixId
@param[type=string] type
@return[type=string]
]]
function MyDungeonsBook:Wa_GenerateId(auraData, instanceId, bossId, affixId, type, someAdditionalText)
    local spellId = auraData.spellId;
    local name = GetSpellInfo(spellId);
    local dungeonMetaInfo = self:GetDungeonMetaInfo(instanceId);
    if (affixId) then
        local affixMetaInfo = self:GetAffixMetaInfo(affixId);
        return string.format("[MDB] Affix - %s - %s [%s] [%s] %s", affixMetaInfo.name or "", name or "", spellId, type, someAdditionalText or "");
    end
    if (bossId) then
        return string.format("[MDB] [%s] %s - %s - %s [%s] [%s] %s", dungeonMetaInfo.addon, dungeonMetaInfo.name or "", dungeonMetaInfo.encounters[bossId].name or "", name or "", spellId, type, someAdditionalText or "");
    end
    return string.format("[MDB] [%s] %s - %s [%s] [%s] %s", dungeonMetaInfo.addon, dungeonMetaInfo.name or "", name or "", spellId, type, someAdditionalText or "");
end

function MyDungeonsBook:Wa_AuraTypeToWaAuraType(auraType)
    if (auraType == "DEBUFF") then
        return "HARMFUL";
    end
    if (auraType == "BUFF") then
        return "HELPFUL";
    end
    return "BOTH";
end

function MyDungeonsBook:Wa_LoadingState_Encounter_Update(wa, bossId)
    if (bossId) then
        wa.load.use_encounterid = true;
        wa.load.encounterid = bossId and "" .. bossId or "";
    end
    return wa;
end

function MyDungeonsBook:Wa_LoadingState_Affix_Update(wa, affixId)
    if (affixId) then
        wa.load.use_affixes = true;
        wa.load.affixes = {single = affixId};
    end
    return wa;
end

function MyDungeonsBook:Wa_LoadingState_Zone_Update(wa, instanceId)
    if (instanceId) then
        local dungeonMetaInfo = self:GetDungeonMetaInfo(instanceId);
        wa.load.use_zoneIds = true;
        if (dungeonMetaInfo.waInfo) then
            wa.load.zoneIds = dungeonMetaInfo.waInfo.gameZoneId;
        end
    end
    return wa;
end
